*
* FORECAST_YEAR in the include will be the year for which the forecast will be calculated
*(choose between 2006 (current year)and 2050)
$SETGLOBAL FORECAST_YEAR 2006

* CPI_YEAR in the include will be the year for real dollars
$SETGLOBAL CPI_YEAR 2006

* Gasoline price for FORECAST_YEAR in CPI_YEAR dollars per gallon
$SETGLOBAL PR_GASOL 1.83

* Natural gas price for FORECAST_YEAR in CPI_YEAR dollars per MMBtu
$SETGLOBAL PR_NTGAS 5.20
* Below are the base prices in future years.
* For crude oil, $26.43 (2003 dollars) per barrel
* For gasoline, $1.83 (2003 dollars) per gallon
* For electricity, $95.19 (2003 dollars) per MWh
* For natural gas, $5.20 (2003 dollars) per mcf, 983 Btu per cf , i.e., $5.29 per MMBtu


$ONTEXT
etap is zero in this version.

The facility to choose the cheapest alternative technology is removed
*This file was created from a copy of CAT_Analysis_NEWEST.gms and edited for use with SAM0506.xls
INDEX TO MODEL SECTIONS
*
  1. OVERALL SETTINGS FOR GAMS AND OUTPUT FILE
    1.1 CONTROLS PLACED ON OUTPUT GENERATION
    1.2 SET UP FILE FOR SOLUTION VALUES
*
  2. SET DEFINITION
    2.1 EXPLICIT SET DECLARATION
    2.2 ALIASES
*
  3. PARAMETERS AND EXOGENOUS VARIABLES
    3.1 SOCIAL ACCOUNTING MATRIX, CAPITAL COEFFICIENT MATRIX AND PARAMETERS
    3.2 PARAMETER DECLARATION
    3.3 CALCULATIONS OF PARAMETERS AND INITIAL VALUES
*
  4. VARIABLES
    4.1 VARIABLE DECLARATION
    4.2 INITIALIZATION OF VARIABLES
    4.3 REMOVING TRACE NUMBERS FOR COMPUTATIONAL PURPOSES
    4.4 SETTING COMPUTATIONALLY USEFUL BOUNDS ON VARIABLES (TO HELP THE SOLVER)
*
  5. PRE-MODEL CHECK OF PARAMETERS AND INITIAL VALUES OF VARIABLES
    5.1 PRINTING CALCULATED PARAMETERS AND EXOGENOUS VARIABLES
    5.2 SAVING INITIAL VALUES FOR VARIABLES
*
  6. EQUATIONS
    6.1 EQUATION DECLARATION
    6.2 EQUATION ASSIGNMENT
      6.2.1 HOUSEHOLDS
      6.2.2 PRODUCERS
      6.2.3 TRADE
      6.2.4 INVESTMENT
      6.2.5 LABOR SUPPLY AND MIGRATION
      6.2.6 HOUSEHOLD INCOME TAXATION
      6.2.7 GOVERNMENT
      6.2.8 MODEL CLOSURE
      6.2.9 MODEL CLOSURE USING FIXED VALUES (COMPUTATIONALLY MORE EFFICIENT THAN EQUATIONS)
*
  7. SOLVE AND OUTPUT PREPARATION
    7.1 MODEL FORMULATION
    7.2 TAX EXPERIMENT LOOP
    7.3 PUT RESULTS INTO OUTPUT FILE
*
$OFFTEXT
*----------------------------------------------------------------
* 1. OVERALL SETTINGS FOR GAMS AND OUTPUT FILE
*----------------------------------------------------------------
* 1.1 CONTROLS PLACED ON OUTPUT GENERATION
*----------------------------------------------------------------
*
$OFFSYMLIST OFFSYMXREF
*
OPTIONS SYSOUT=OFF, SOLPRINT=OFF, LIMROW=1000, LIMCOL=0;
*
*----------------------------------------------------------------
* 1.2 SET UP FILE FOR SOLUTION VALUES
*----------------------------------------------------------------
*
  FILE RES /EDRAM5ma.RES/; RES.PW = 250; RES.ND = 6; RES.LW = 13;
                         RES.NW =  13; RES.LJ = 1; PUT RES;
*
*----------------------------------------------------------------
* 2. SET DEFINITION
*----------------------------------------------------------------
* 2.1 EXPLICIT SET DECLARATION
*----------------------------------------------------------------
SETS  AZ  ALL ACCOUNTS IN SOCIAL ACCOUNTING MATRIX /
 ACCHOT    ACC Other
 ACCRST    Full Service Restaurants
 ADMBLD    Building Maintenance
 ADMOTH    Other Administrative Services
 ADMSEC    Security Services
 ADMTMP    Temporary Administrative Services
 AGRIC     Agriculture
 APPREL    Apparel Manufacturing
 BEVTOB    Beverage and Tobacco Products
 BUSSRV    Business Services
 CEMENT    Cement
 CHMBAS     Basic Chemical Manufacture
 CHMDRG    Chemical and Drugs Manufacture
 CHMOTH     Other Chemical Products Manufacture
 CHMSPS     Soaps and Detergents Manufacture
 CMPAUD    Audio equipment
 CMPCMM    Communications Equipment Manufacture
 CMPINS    Electronic Instruments Manufacture
 CMPMED    Electronic Recording Media Manufacture
 CMPMFG    Computer Manufacture
 CMPRTS    Electronic Components Manufacture
 CONNON    Nonresidential Construction
 CONRES    Residential Construction
 DISTEL    Electrical Power Generation and Distribution
 DSTGAS    Natural Gas Distribution
 DSTOTH    Water Distribution and Sewage Treatment
 EDUC      Education
 ELCTRC    Electrical Equipment Manufacture
 FIBNKS    Banking
 FINSUR    Insurance
 FINOTH    Other Financial
 FIREAL    Real Estate
 FINSEC    Financial Securities
 FDMFG     Food Manufacturing
 FDOTH     Other Food Related Industry
 FDPROC    Food Processing
 FURN      Furniture
 GLASS      Glass Products Manufacture
 INDGAS    Industrial Gas
 INFCOM    Internet and Information Services
 INFOPC    Motion Picture Industry
 INFOTH    Other Broadcasting and Recording Industry
 INFOTL    Telecommunications
 LABDNT    Laboratory and Dental Equipment
 MACHIN    Machinery Manufacture
 MEDAMB    Medical Services
 MEDHSP    Hospitals
 MEDNRS    Nursing
 MEDSA     Day Care
 MTLFAB    Metal Fabrication
 MSCMFG    Miscellaneous Manufacturing
 OILGAS    Petroleum and Natural Gas Extraction
 OILREF    Oil Refineries
 OTHPRI    Mining
 PAPER     Paper Products Manufacturing
 PERSRV    Personal Services
 PLASTC     Plastics Manufacture
 PRIMTL    Primary Metals
 PRINT     Printing
 PROACC    Accounting
 PROADV    Advertising
 PROARC    Architecture
 PROCOM    Computer Related Services
 PROCNS    Consulting
 PRODES    Design
 PROLEG    Legal Services
 PROOTH    Other Professional Services
 PRORES    Research
 PLPMLL    Pulp and Paper Mills
 RECAMS    Amusement Parks
 RECENT    Recreation and Entertainment
 RETVEH    Retail Vehicles and Parts
 RETGAS    Retail Gasoline Stations
 RETMSC    Retail Miscellaneous and Other
 CONCRT    Concrete
 SCAOTH    China and Clay Products
 TEXLTH    Textile and Leather Manufacturing
 TRANSP    Transportation
 VEHAER    Aerospace Manufacture
 VEHBDY    Motor Vehicle Body Manufacture
 VEHMFG    Vehicle Manufacture
 VEHOTH    Other Vehicle Manufacture
 VEHPRT    Motor Vehicle Parts Manufacture
 VEHSHP    Ship Building and Repair
 WHLAGN    Wholesale Trade
 WOOD      Wood Products Manufacturing
 LABOR   FACTOR     FACTOR LABOR
 CAPIT   FACTOR     FACTOR ALL OTHER FACTORS COMBINED AS CAPITAL
 FTSOC   GOVERNMENT FEDERAL    TAX      SOCIAL SECURITY
 FTPIT   GOVERNMENT FEDERAL    TAX      PERSONAL INCOME TAX
 FTPRO   GOVERNMENT FEDERAL    TAX      PROFITS
 FTDUT   GOVERNMENT FEDERAL    TAX      DUTY
 FTMSC   GOVERNMENT FEDERAL    TAX      MISCELLANEOUS
 CTHHS   GOVERNMENT CALIFORNIA TAX      VARIOUS HOUSEHOLD TAXES
 CTBOZ   GOVERNMENT CALIFORNIA TAX      ALCOHOL TAXES
 CTCIG   GOVERNMENT CALIFORNIA TAX      CIGARETTE TAXES
 CTHOR   GOVERNMENT CALIFORNIA TAX      HORSE RACING
 CTEST   GOVERNMENT CALIFORNIA TAX      ESTATE TAXES
 CTTRL   GOVERNMENT CALIFORNIA TAX      TRAILER FEES
 CTLIC   GOVERNMENT CALIFORNIA TAX      MOTOR VEHICLE LICENSE FEES
 CTDIE   GOVERNMENT CALIFORNIA TAX      DIESEL FUEL TAXES
 CTREG   GOVERNMENT CALIFORNIA TAX      MOTOR VEHICLE REGISTRATION FEES
 CTMSC   GOVERNMENT CALIFORNIA TAX      MISCELLANEOUS
 CTINS   GOVERNMENT CALIFORNIA TAX      INSURANCE GROSS PREMIUM TAX
 CTGAS   GOVERNMENT CALIFORNIA TAX      GASOLINE FUEL TAXES
 CTSAU   GOVERNMENT CALIFORNIA TAX      SALES AND USE TAXES
 CTBAC   GOVERNMENT CALIFORNIA TAX      BANK AND CORPORATION TAX
 CTLAB   GOVERNMENT CALIFORNIA TAX      LABOR TAXES   UI AND WORKERS COMP
 CTPIT   GOVERNMENT CALIFORNIA TAX      PERSONAL INCOME TAX
 CTRGU   GOVERNMENT CALIFORNIA TAX      REGULATORY LICENSES AND FEES
 CTSVC   GOVERNMENT CALIFORNIA TAX      SERVICES TO THE PUBLIC
 CTPAM   GOVERNMENT CALIFORNIA TAX      USE OF PROPERTY AND MONEY
 CGENF   GOVERNMENT CALIFORNIA GENERAL FUND
 LTPRP   GOVERNMENT LOCAL      TAX      PROPERTY
 LTSAU   GOVERNMENT LOCAL      TAX      SALES AND USE
 LTFMS   GOVERNMENT LOCAL      TAX      MISCELLANEOUS ON FIRMS
 LTHHS   GOVERNMENT LOCAL      TAX      MISCELLANEOUS ON HOUSEHOLDS
 LTMSC   GOVERNMENT LOCAL      TAX      MISCELLANEOUS ON FIRMS AND HOUSEHOLDS
 FSNON   GOVERNMENT FEDERAL    SPENDING NON DEFENSE
 FSDEF   GOVERNMENT FEDERAL    SPENDING DEFENSE
 CSTRA   GOVERNMENT CALIFORNIA SPENDING TRANSPORTATION
 CSCOR   GOVERNMENT CALIFORNIA SPENDING CORRECTIONS
 CSK14   GOVERNMENT CALIFORNIA SPENDING K TO 14 EDUCATION
 CSUNI   GOVERNMENT CALIFORNIA SPENDING UNIVERSITIES
 CSWEL   GOVERNMENT CALIFORNIA SPENDING WELFARE
 CSHTH   GOVERNMENT CALIFORNIA SPENDING HEALTH
 CSOTH   GOVERNMENT CALIFORNIA SPENDING OTHER
 LSTRA   GOVERNMENT LOCAL      SPENDING TRANSPORTATION
 LSCOR   GOVERNMENT LOCAL      SPENDING CORRECTIONS
 LSK14   GOVERNMENT LOCAL      SPENDING K TO 14 EDUCATION
 LSWEL   GOVERNMENT LOCAL      SPENDING WELFARE
 LSHTH   GOVERNMENT LOCAL      SPENDING HEALTH
 LSOTH   GOVERNMENT LOCAL      SPENDING OTHER
 CFOOD   COMMODITY  FOOD AND BEVERAGE
 CHOME   COMMODITY  SHELTER
 CFUEL   COMMODITY  FUEL AND UTILITIES
 CFURAP  COMMODITY  HH OPERATIONS & FURNISHINGS AND APPAREL
 CTRNS   COMMODITY  TRANSPORTATION
 CMFUEL  COMMODITY  MOTOR FUEL
 CMEDS   COMMODITY  MEDICAL CARE
 CRESID  COMMIDITY  RESISDUAL EXPENDITURES
 HOUS1   HOUSEHOLD  1.0 PERCENT MARGINAL CA PIT
 HOUS2   HOUSEHOLD  2.0 PERCENT MARGINAL CA PIT
 HOUS4   HOUSEHOLD  4.0 PERCENT MARGINAL CA PIT
 HOUS6   HOUSEHOLD  6.0 PERCENT MARGINAL CA PIT
 HOUS8   HOUSEHOLD  8.0 PERCENT MARGINAL CA PIT
 HOUS9   HOUSEHOLD  9.3 PERCENT MARGINAL CA PIT UNDER 200K
 HOUSH   HOUSEHOLD  9.3 PERCENT MARGINAL CA PIT OVER 200K
 INVES   INVESTMENT
 ROW     REST OF WORLD  /

*
      C(AZ)      COMPOSITE COMMODITIES    / CFOOD, CHOME, CFUEL, CTRNS, CMFUEL, CMEDS, CFURAP, CRESID /


      F(AZ)      FACTORS                  / LABOR, CAPIT /
*
      G(AZ)      GOVERNMENTS              / FTSOC, FTPIT, FTPRO, FTDUT, FTMSC, CTHHS, CTBOZ, CTCIG, CTHOR, CTEST,
                                           CTTRL, CTLIC, CTDIE, CTREG, CTMSC, CTINS, CTGAS, CTSAU, CTBAC, CTLAB,
                                           CTPIT, CTRGU, CTSVC, CTPAM, CGENF, LTPRP, LTSAU, LTFMS, LTHHS, LTMSC,
                                           FSDEF, FSNON, CSTRA, CSCOR, CSK14, CSUNI, CSWEL, CSHTH, CSOTH, LSTRA,
                                           LSCOR, LSK14, LSWEL, LSHTH, LSOTH /
*
      GC(G)     CALIFORNIA SPENDING      / CSTRA, CSCOR, CSK14, CSUNI, CSWEL, CSHTH, CSOTH /
*
      GED(G)    EDUCATION UNITS          / CSK14, CSUNI, LSK14 /
*
      GL(G)     LOCAL GOVERNMENT UNITS   / LSTRA, LSCOR, LSK14, LSWEL, LSHTH, LSOTH /
*
      GN(G)     ENDOGENOUS GOVERNMENTS   / CSTRA, CSCOR, CSK14, CSUNI, CSWEL, CSHTH, CSOTH,
                                           LSTRA, LSCOR, LSK14,        LSWEL, LSHTH, LSOTH /
*
      GX(G)     EXOGENOUS GOVERNMENTS    / FSDEF, FSNON /
*
      GS(G)     SALES OR EXCISE TAXES    / FTMSC, CTBOZ, CTCIG, CTHOR, CTTRL, CTLIC, CTDIE, CTREG, CTMSC, CTINS,
                                           CTGAS, CTSAU, CTRGU, CTPAM, LTPRP, LTSAU, LTFMS, LTMSC /
*
      GF(G)     FACTOR TAXES             / FTSOC, FTPRO, CTBAC, CTLAB /
*
      GI(G)     INCOME TAX UNITS         / FTPIT, CTPIT, LTPRP /
      GH(G)     HOUSEHOLD TAX UNITS      / FTMSC, CTHHS, CTEST, CTRGU, CTSVC, LTHHS, LTMSC /
*
      GNS(G)    INFRASTRUCTURE GOV'TS    / CSTRA, CSCOR, CSWEL, CSHTH, CSOTH, LSTRA, LSCOR, LSHTH, LSOTH /

      GW(G)     TRANSFER PAYMENTS        / FSNON, CSWEL, LSWEL /
*
      GSF(G)     CA SPECIAL FUNDS UNITS   / CTHHS, CTBOZ, CTCIG, CTHOR, CTLIC, CTDIE, CTREG, CTMSC, CTINS, CTGAS,
                                           CTSAU, CTRGU, CTSVC, CTPAM /
*
      GT(G)     TAX UNITS                / FTSOC, FTPIT, FTPRO, FTDUT, FTMSC, CTHHS, CTBOZ, CTCIG, CTHOR, CTEST,
                                           CTTRL, CTLIC, CTDIE, CTREG, CTMSC, CTINS, CTGAS, CTSAU, CTBAC, CTLAB,
                                           CTPIT, CTRGU, CTSVC, CTPAM, LTPRP, LTSAU, LTFMS, LTHHS, LTMSC /
*

      GLT(G)    LOCAL TAX UNITS         /LTPRP, LTSAU, LTFMS, LTHHS, LTMSC/
*
       H(AZ)      HOUSEHOLDS               / HOUS1, HOUS2, HOUS4, HOUS6, HOUS8, HOUS9, HOUSH /
*
       Q1(H)     FIRST (LOWEST) INCOME "QUARTILE"    /HOUS1/
       Q2(H)     SECOND INCOME "QUARTILE"            /HOUS2, HOUS4/
       Q3(H)     THIRD (HIGHEST)INCOME "QUARTILE"    /HOUS6, HOUS8, HOUS9, HOUSH/


       AI(AZ)      INDUSTRY SECTORS
                    /
                    AGRIC,    OILGAS,   OTHPRI,   DISTEL,   DSTGAS,
                    DSTOTH,   CONRES,   CONNON,   FDMFG,    FDPROC,
                    FDOTH,    BEVTOB,   TEXLTH,   APPREL,   WOOD,     PLPMLL,   PAPER,    PRINT,    OILREF,
                    INDGAS,   CHMDRG,   CHMBAS,   CHMSPS,   CHMOTH,   PLASTC,   GLASS,    CEMENT,
                    CONCRT,   SCAOTH,   PRIMTL,   MTLFAB,   MACHIN,   CMPMFG,   CMPCMM,
                    CMPRTS,   CMPINS,   CMPMED,   ELCTRC,   VEHMFG,   VEHBDY,   VEHPRT,
                    VEHSHP,   VEHOTH,   VEHAER,   FURN,     LABDNT,   MSCMFG,
                    WHLAGN,   TRANSP,   CMPAUD,
                    RETVEH,   RETGAS,
                    RETMSC,   INFOPC,   INFOTH,   INFOTL,
                    INFCOM,   FINSEC,   FINSUR,   FIBNKS,   FIREAL,   FINOTH,   PROLEG,   PROACC,
                    PROARC,   PRODES,   PROCOM,   PROCNS,   PRORES,   PROADV,   PROOTH,   BUSSRV,
                    ADMTMP,   ADMSEC,   ADMBLD,   ADMOTH,   EDUC,     MEDAMB,   MEDHSP,
                    MEDNRS,   MEDSA,    RECENT,   RECAMS,   ACCHOT,   ACCRST,
                    PERSRV
                 /

     TI(AI)     PERMIT SECTORS / OILGAS,   DISTEL,   DSTGAS,    DSTOTH,  OILREF,
                               CEMENT  /

    TIC(AI)    NON PERMIT SECTORS

    K         NUMBER OF ALTERNATIVES  /1*3/
*
*
      T         EXPERIMENT LOOP                 / BASE, B_A_U, SCEN1, SCEN2 /
*
*

      R1H       REPORT 1 FOR SCALARS     / FORYR  'FORECAST YEAR                   ',
                                           CPIYR  'CPI YEAR                        ',
                                           OUT_N  'NOMINAL CA OUTPUT ($BILLION)    ',
                                           OUT_R  'REAL CA OUTPUT ($BILLION)       ',
                                           GSP    'GROSS STATE PRODUCTS ($BILLION) ',
                                           GSP_R  'REAL GSP ($BILLION)             ',
                                           SPI    'CALIFORNIA PERSONAL INCOME      ',
                                           SPI_R  'REAL SPI ($BILLION)             ',
                                           SPICAP 'SPI PER CAPITA ($THOUSANDS)     ',
                                           LD     'LABOR DEMAND (MILLIONS)         ',
                                           CRBCP  'CARBON CAP (MMT CO2)            ',
                                           CRBRT  'CARBON PRICE ($ PER TON CO2E)   ',
                                           CRBRV  'CARBON TAX RECYCLED ($BILLION)  ',
                                           CRBTX  'CARBON TAX COLLECTED  ($BILLION)',
                                           IMPRT  'TOTAL IMPORTS ($BILLION)        ',
                                           EXPRT  'TOTAL EXPORTS ($BILLION)        ',
                                           WRKRS  'WORKING FAMILIES (MILLIONS)     ',
                                           GN     'GROSS INVESTMENT                ',
                                           PINV   'NET PRIVATE INVEST ($MILLION)   ',
                                           POP    'POPULATION (MILLION FAMILIES)   ',
                                           W      'WAGE INDEX (BASE = 100)         ',
                                           R      'RETURN TO CAPITAL INDEX         ',
                                           KD     'CAPITAL STOCK ($100 BILLION)    ',
                                           CPI    'CONSUMER PRICE INDEX (BASE=1)   ',
                                           BAC    'BANK AND CORP TAX REVENUE       ',
                                           PIT    'PERSONAL INCOME TAX REVENUE     ',
                                           SAU    'SALES AND USE TAX REVENUE       ',
                                           GFREV  'GENERAL FUND REVENUE            ',
                                           SFREV  'SPECIAL FUND REVENUE            ',
                                           SUBSS  'TOTAL SUBSIDIES                 ',
                                           STATIC 'STATIC REVENUE ESTIMATE         ',
                                           DGF    'CHANGE IN GENERAL FUND          ',
                                           DSF    'CHANGE IN SPECIAL FUND          ',
                                           DDRE   'DOLLARS DYNAMIC REVENUE EFFECT  ',
                                           PDRE   'PERCENT DYNAMIC REVENUE EFFECT  ',
                                           GFSAV  'GENERAL FUND BALANCE            ',
                                           MIC    'MANUFACTURERS INVESTMENT CREDIT ',
                                           PROP98 'PROP 98 TRANSFER TO K14 EDUC    '/
*
*
*
      R2H       REPORT 2 FOR STATUS      / M-STAT, S-STAT /
*
      R3H       REPORT 3 FOR SECTORS     / IGT    'TRANSFERS FROM GF  ',
                                           GOVS   'GOVT SAVINGS       ',
                                           Y      'INCOMES            ',
                                           CG      'GOVT CONSUMPTION  ',
                                           YD      'DISPOSABLE INCOME '   /

     R4H       REPORT 4 FOR INDUSTRIES   / INTERMED       'AVG% INCR. INTRMDS DUE TO REGS  ',
                                            INTRMD1        '$ INCR. SPENDING ON INTERMEDS   ',
                                            DS             'OUTPUT ($BILLION)  ',
                                            D1DS           'CHANGE OUTPUT                   ',
                                            D2DS           '% CHANGE OUTPUT                 ',
                                            TAX            'IMPLICIT TAX RATE TAUQ          ',
                                            INDUSTD        'INDUSTRY DEMAND                 ',
                                            HOUSED         'HOUSEHOLD DEMAND                ',
                                            GOVTD          'GOVT DEMAND                     ',
                                            FDK            'CAPITAL ($100 BILLION)          ',
                                            D1FDK          'CHANGE CAPITAL                  ',
                                            D2FDK          '% CHANGE CAPITAL                ',
                                            FDL            'JOBS (MILLIONS)    ',
                                            D1FDL          'CHANGE JOBS                     ',
                                            D2FDL          '% CHANGE JOBS                   ',
                                            P              'PRICE (BASE=1)     ',
                                            D1P            'CHANGE PRICE                    ',
                                            D2P            '% CHANGE PRICE                  ',
                                            PVA            'PRICE VALUE ADDED  ',
                                            D1PVA          'CHANGE PVA                      ',
                                            D2PVA          '%CHANGE PVA                     ',
                                            VA             'VALUE ADDED ($B)   ',
                                            D1VA           'CHANGE PVA                      ',
                                            D2VA           '%CHANGE PVA                     ',
                                            PD             'DOMESTIC PRICE                  ',
                                            M              'IMPORTS ($BILLION) ',
                                            D1M            'CHANGE IMPORTS                  ',
                                            D2M            '% CHANGE IMPORTS                ',
                                            X              'EXPORTS ($BILLION) ',
                                            D1X            'CHANGE EXPORTS                  ',
                                            D2X            '% CHANGE EXPORTS                ',
                                            CARBPR         'CO2E PRODUCED (MMT)',
                                            CARBIMP        'CO2E IMPORTED (MMT)',
                                            CO2ELC         'ELCTR CO2 COST ($B)',
                                            RRL            'LABOR RENTAL RATE (BASE=100)    ',
                                            D1RRL          'CHANGE LABOR RENTAL RATE        ',
                                            D2RRL          '%CHANGE LABOR RENTAL RATE       ',
                                            RRK            'CAPITAL RENTAL RATE (BASE=100)  ',
                                            D1RRK          'CNANGE CAPITAL RENTAL RATE      ',
                                            D2RRK          '% CHANGE CAPITAL RENTAL RATE    ',
                                            FTAXK          'K FACTOR TAX                    ',
                                            FTAXL          'L FACTOR TAX                    ',
                                            KRETURN        'PRE-TAX K-RETURN                ',
                                            LRETURN        'PRE-TAX L-RETURN                ',
                                            CH0A           'SPENDING PORTION OF CH0(I)      ',
                                            CH0B           'TAX PORTION OF CH0(I)           '/
*
*
R4LH(R4H) SMALL REPORT 4 FOR INDUSTRIES   / DS             'OUTPUT ($BILLION)               ',
*                                            D1DS           'CHANGE OUTPUT                   ',
*                                            D2DS           '% CHANGE OUTPUT                 ',
                                            P              'PRICE (BASE=1)                  ',
*                                            D1P            'CHANGE PRICE                    ',
*                                            D2P            '% CHANGE PRICE                  ',
                                            M              'IMPORTS ($BILLION)              ',
*                                            D1M            'CHANGE IMPORTS                  ',
*                                            D2M            '% CHANGE IMPORTS                ',
                                            X              'EXPORTS ($BILLION)              ',
*                                            D1X            'CHANGE EXPORTS                  ',
*                                            D2X            '% CHANGE EXPORTS                ',
                                            FDL            'JOBS (MILLIONS)                 ',
*                                            D1FDL          'CHANGE JOBS                     ',
*                                            D2FDL          '% CHANGE JOBS'
                                            CARBPR         'CO2E PRODUCED (MMT)',
                                            CARBIMP        'CO2E IMPORTED (MMT)'
/
*
      MS        LABELS FOR MODEL STATUS  / 01 ' OPTIMAL_GLOB',
                                           02 ' OPTIMAL_LOCL',
                                           03 '    UNBOUNDED',
                                           04 ' INFES_GLOBAL',
                                           05 ' INFES__LOCAL',
                                           06 ' INTER_INFEAS',
                                           07 ' INTER_NON-OP',
                                           08 ' INTEG__SOLVE',
                                           09 ' INTER_NONINT',
                                           10 ' INTEG__INFES',
                                           11 '       UNUSED',
                                           12 ' ERROR_UNKNWN',
                                           13 ' ERROR_NOSOLN'/
*
      SS        LABELS FOR SOLVER STATUS / 01 '      OPTIMAL',
                                           02 '   ITERATIONS',
                                           03 '    RESOURCES',
                                           04 ' TERM__SOLVER',
                                           05 ' VALERR_LIMIT',
                                           06 '      UNKNOWN',
                                           07 '     NOT_USED',
                                           08 ' ERROR_PREPRO',
                                           09 ' ERROR__SETUP',
                                           10 ' ERROR_SOLVER',
                                           11 ' ERROR_INTERN',
                                           12 ' ERROR_POSTPR',
                                           13 ' ERROR_SYSTEM'/

      CC(C)     ALL BUT THE LAST CONSUMPTION GOOD /CFOOD, CHOME, CFUEL, CTRNS, CMFUEL, CMEDS, CFURAP/
      CNOT(C)   LAST CONSUMPTION GOOD             /CRESID/
      RW(AZ)     REST OF WORLD                     /ROW/
      CP(AZ)     NOT CONSUMER + INDUSTRY PRICES                          ;
      CP(AZ) = YES;  CP(AI) = NO; CP(C) = NO;

*----------------------------------------------------------------
* 2.2 ALIASES
*----------------------------------------------------------------
*
  ALIAS (AI,AJ), (AI,AI1), (AZ,AZ1), (F,F1), (G,G1), (GI,GI1), (GS,GS1), (H,H1), (C,C1), (T,T1), (GC,GC1), (CC,CC1), (CC,CC2) ;
*
*----------------------------------------------------------------
* 3. PARAMETERS AND EXOGENOUS VARIABLES
*----------------------------------------------------------------
* 3.1 SOCIAL ACCOUNTING MATRIX, CAPITAL COEFFICIENT MATRIX AND PARAMETERS
*----------------------------------------------------------------
*

parameters
sam(Az,Az1)        Social Accounting Matrix
ccm(Ai,Ai1)        Capital Coefficient Matrix
ccm_sumofrows(Ai,Ai1)        Capital Coefficient Matrix
ccm_sumofcolumns(Ai,Ai1)        Capital Coefficient Matrix
miscg(g,h,*)     Table MISCG Tax Table Figures
misc(Az,*)        Table MISC Miscellaneous Sectoral data
misch(h,*)       Table MISCH Miscellaneous Household data
tpc(h,g)         Table TPC Fraction of Non-Working Households Collecting Transfer Payments
atax(gi1,gi)     Table ATAX Deductibility of other Taxes
tauff(g,f)       Table TAUFF Assignment of Factor Taxes
omega(f)         Table OMEGA Rate at which Factor Payments Apear in PIT Calculations
alfa(CC,H)       IDS ALPHA CONSTANT
gamma(H,CC,CC1)  IDS GAMMA COEFFICIENT
beta(CC,H)       IDS BETA COEFFICIENT
kapp(H)          IDS PARAMETER  /HOUS1=0.2,HOUS2=0.1,HOUS4=0.1,HOUS6=0,HOUS8=0,HOUS9=0,HOUSH=0/
lambda(H)        IDS PARAMETER  /HOUS1=0.9,HOUS2=0.1,HOUS4=0.1,HOUS6=0.7,HOUS8=0.7,HOUS9=0.7,HOUSH=0.7/
itce(Az,Az1)       Table ITCE For Investment Tax Credit ;
*-------------------------------------------------------------------------------
*        Loading parameters form Excel spreadsheets
*-------------------------------------------------------------------------------
**EOM 2/13/09 once the .gdx files are created the excel interface commands are no
**longer necessary and can be commented out, which will greatly increase
**processing speed.


*$call gdxxrw.exe SAM0506_agg_11-24-09.xlsx par=sam rng=SAM0506!A1:EU151
$gdxin SAM0506_agg_11-24-09.gdx
$loaddc sam
$gdxin
*$batinclude tauqxer
* to treat all the taxes as taxes on i not c.  Does not change feasibility
*$batinclude tauqxer.gms
*

*$call gdxxrw.exe N00506_agg_11-25-09.xlsx par=ccm rng=Percentage_CCM!A1:CI87
$gdxin N00506_agg_11-25-09.gdx
$loaddc ccm
$gdxin


*$call gdxxrw.exe alfa_8-26-09.xls par=alfa rng=A1:H8
$gdxin alfa_8-26-09.gdx
$loaddc alfa
$gdxin
*
*$call gdxxrw.exe gamma_8-26-09.xls par=gamma rng=A1:I57 rdim=2 cdim=1
$gdxin gamma_8-26-09.gdx
$loaddc gamma
$gdxin
*
*$call gdxxrw.exe beta_8-26-09.xls par=beta rng=A1:H8
$gdxin beta_8-26-09.gdx
$loaddc beta
$gdxin
*

*$call gdxxrw.exe MSC0506.xlsx par=miscg rng=MSC0506!B3:I24 rdim=2 cdim=1 par=misc rng=MSC0506!B27:G128 par=misch rng=MSC0506!B131:J138 par=tpc rng=MSC0506!B141:E148 par=atax rng=MSC0506!B151:E154 par=tauff rng=MSC0506!B157:D161 par=omega rng=MSC0506!B165:C166 rdim=1 cdim=0 par=itce rng=MSC0506!B169:R193
$gdxin MSC0506.gdx
$loaddc miscg misc misch tpc atax tauff omega itce
$gdxin

itce(az,az1) = 0;
display  miscg, misc, misch, tpc, atax, tauff, omega, itce     ;

*******************
set I(AI);
I(AI) = yes ;
set Z(AZ);
Z(AZ) = yes ;
ALIAS (I,J), (I,I1), (z,z1);
*$batinclude aggregator2
* test ftsoc

display itce ;




*******************

*display sam, ccm, miscg, alfa,gamma,beta, misc, misch, tpc, atax, tauff, omega, itce;
*------------------------------------------------------------------------------
* Carbon intensity in million metric tons CO2e per billion dollars of fuel combusted
parameters
  TCINTENS(AI)   CAT     REAL  CARBON DIOXIDE INTENSITY OF TRADED GOODS IN MILLION METRIC TONS PER BILLION DOLLARS
  CINTENS(AI,AJ)  CAT     REAL    CARBON DIOXIDE INTENSITY IN MILLION METRIC TONS PER BILLION DOLLARS  ;
*
  CINTENS(I,J) = 0;
  TCINTENS(I) = 0;

* For crude oil, 419 kg CO2 per barrel, $29.22 per barrel (2006 dollars)
  CINTENS('OILGAS','OILREF') = 14.34;
* For natural gas, 52.94 kg CO2e per MMBtu, $7.69 (2006 dollars) per MMBtu in 2020
  CINTENS('OILGAS','DSTGAS') = 6.88;
  CINTENS('OILGAS','DISTEL') = 6.88;
  TCINTENS('DSTGAS') = 6.88;
* For imported electricity, 708 lb CO2 per MWh, $111.82 (2006 dollars) per MWh in 2020
  TCINTENS('DISTEL') = 2.88;
* For imported gasoline, 8,55 kg CO2 per gallon, $2.28 (2006 dollars) per gallon in 2020
  TCINTENS('OILREF') = 3.75;

*-------------------------------------------------------------------------------
*
*-------------------------------------------------------------------------------

*----------------------------------------------------------------
* 3.x SAM forecasting               (Ralf)
*----------------------------------------------------------------
* FORECAST_YEAR in the include will be the year for which the forecast will be calculated
*(choose between 2003 (current year)and 2050)
* CPI_YEAR in the include will be the year for real dollars

$BATINCLUDE FutureYears06_agg.gms

**
*----------------------------------------------------------------
* 3.2 PARAMETER DECLARATION
*----------------------------------------------------------------
*
  SCALARS
*
  ADA           DOF     CHANGE IN AVERAGE DAILY ATTENDANCE  / 1.00 /
  DEPR          DOF     DEPRECIATION RATE;
*
  PARAMETERS
*
* PARAMETERS CALCULATED FROM SOCIAL ACCOUNTING MATRIX DATA
*
  A(AZ,AZ1)       IMPLAN  INPUT OUTPUT COEFFICIENTS
  AD(AZ,AZ1)      IMPLAN  DOMESTIC INPUT OUTPUT COEFFICIENTS
  AG(AZ,G)       IMPLAN  GOVERNMENT SPENDING SHARES OF NET INCOME
  ALPHA(F,AI)    IMPLAN  FACTOR SHARE EXPONENTS IN PRODUCTION FUNCTION
  ALPHA0(C,H)   DOF     CONSTANT IN LA-AIDS CONSUMPTION FUNCTION
  ALPHACG(AI,G)  DOF     GOVERNMENT CONSUMPTION SHARES OF GOODS
  ALPHAFG(F,G)  DOF     GOVERNMENT SHARES OF FACTOR RENTALS
  FITC(F,G)     DOF     ALLOCATION OF ITC TO FACTORS
  IGTD(G,G1)    DOF     TYPES OF INTER GOVERNMENTAL TRANSFERS
  SIGMAH(H)     DOF     AVERAGE PROPENSITY TO SAVE
  TAUF(G,F,AZ)   DOF     FACTOR TAXES
  TAUFX(G,F,aZ)  DOF     EXPERIMENTAL FACTOR TAXES
  TAUFH(G,F)    DOF     EMPLOYEE PORTION OF FACTOR TAXES
  TAUH(G,H)     DOF     HOUSEHOLD TAXES OTHER THAN PIT
  TAUM(G,AI)     DOF     IMPORT DUTY RATES
  TAUQ(G,AI)     DOF     INITIAL SALES TAX RATES
  TAUQX(G,AI)    DOF     EXPERIMENTAL SALES TAX RATES
  TAUC(G,C)     UCB     AD VALOREM TAXES ON COMPOSITE CONSUMPTION GOODS
  TAUCX(G,C)    UCB     EXPERIMENTAL AD VALOREM TAXES ON COMPOSITE CONSUMPTION GOODS
  TAXS(G,G1)    DOF     TAX DESTINATION SHARES
  KAPPA(GNS)    DOF     POLICY WEIGHTS OF GOV'T SPENDING FOR INSFRASTRUCTURE SCALE VARIABLE
  TEST(T)       DOF     EXPERIMENT PARAMETER
*
* ELASTICITIES AND TAX PARAMETERS
*
  ETAE(AI)       UCB     EXPORT ELASTICITIES WITH RESPECT TO DOMESTIC PRICE
  ETAGS(AI)      UCB     PRODUCTION ELASTICITIES WITH RESPECT TO INFRASTRUCTURE SPENDING
  ETAED(H)      DOF     SENSIVITIY OF MIGRATION TO PUBLIC EDUCATION SPENDING
  ETAI(AI)       UCB     INVESTMENT SUPPLY ELASTICITY
  ETAM(AI)       UCB     IMPORT ELASTICITIES WITH RESPECT TO DOMESTIC PRICE
  ETARA(H)      UCB     L SUPPLY ELASTICITY WITH RESPECT TO AVERAGE WAGE
  ETAPIT(H)     UCB     L SUPPLY ELASTICITY WITH RESPECT TO TAXES
  ETAYD(H)      UCB     RESPONSIVENESS OF INMIGRATION TO AFTER TAX EARNINGS
  ETAU(H)       UCB     RESPONSIVENESS OF INMIGRATION TO UNEMPLOYMENT
  ETATP(H)      UCB     HOUSEHOLD RESPONSE TO TRANSFER PAYMENTS
  ITCX(aZ,aZ1)    DOF     INVESTMENT TAX CREDIT SHARE ALLOWED
  JOBCOR        CALC    CORRECTION FACTOR BETWEEN HOUSEHOLDS AND JOBS
  MIGRFACTOR    CALC    FRACTION OF BASE POPULATION INVOLVED IN MIGRATION
  MTR(G,H)      DOF     MARGINAL TAX RATES
  NRPG(H)       UCB     NATURAL RATE OF POPULATION GROWTH
  PHI(az,C)      DOF     SHARES OF CONSUMPTION COMMODITIES
  SIGMA(AI)      UCB     ELASTICITY OF FACTOR SUBSTITUTION
  TAXBASE(G,H)  DOF     BASE TAX AMOUNTS
  TAXBM(G,H)    DOF     TAX BRACKET MINIMUM
  TAXCVC(G,H)   DOF     TAX CONSTANT TO CORRECT TO OBSERVED TAXES
  TAXOD(G,H)    DOF     TAX OTHER DEDUCTIONS PER RETURN
  TAXPI(G,H)    DOF     TAX PERCENT ITEMIZING
  TAXSD(G,H)    DOF     TAX STANDARD DEDUCTIONS PER RETURN

  CAPFOR(F)             CAPIT PAYMENT FOR FORIENGER
* ARRAYS BUILT TO REPORT RESULTS TO SEPARATE FILE
*
  R1(R1H,T)     REPORT  SCALAR VARIABLES
  R2(R2H,T)     REPORT  SOLVER AND MODEL STATUS VALUES
  R3(R3H,aZ,T)   REPORT  SECTORAL VARIABLES
  R4(R4H,AI,T)   REPORT  ECONOMIC VARIABLES FOR INDUSTRIAL SOURCES
*
* INITIAL VALUES OF ENDOGENOUS VARIABLES
*
  AGI0(H)       DOF     NOMINAL PER HOUSEHOLD ADJUSTED GROSS INCOME FOR PIT PURPOSES
  CARBON0(AI)    CALC    REAL    CARBON DIOXIDE EMISSIONS
  CG0(AI,G)      DOF     REAL    GOVERNMENT CONSUMPTION
  CH0(AI)        IMPLAN  REAL    PRIVATE CONSUMPTION
  CN0(AI)        IMPLAN  REAL    INVESTMENT BY SECTOR OF SOURCE
  CS0(C,H)      DOF     SHARE   HOUSEHOLD CONSUMPTION SHARES
  CPI0(H)       CALC    PRICE   CONSUMER PRICE INDICES
  CX0(AI)        IMPLAN  REAL    EXPORT CONSUMPTION
  DD0(aZ)        CALC    REAL    DOMESTIC DEMAND
  DS0(aZ)        CALC    REAL    DOMESTIC SUPPLY QUANTITIES
  E0(AI)         CALC    REAL    INFRASTRUCTURE SCALE VARIABLE FOR PRODUCTION FUNCTIONS
  FD0(F,aZ)      IMPLAN  REAL    FACTOR DEMAND
  GST0          CALC    REAL    TOTAL GOVERNMENT SPENDING INCLUDING FACTOR RENTALS
*  GSED0         CALC    REAL    TOTAL STATE AND LOCAL EDUCATION SPENDING
  HH0(H)        DOF     HHDS    NUMBER OF HOUSEHOLDS
  HN0(H)        DOF     HHDS    NUMBER OF NONWORKING HOUSEHOLDS
  HW0(H)        DOF     HHDS    NUMBER OF WORKING HOUSEHOLDS
  IGT0(G,G1)    DOF     NOMINAL INTER GOVERNMENTAL TRANSFERS
  ITC0(AI)       DOF     NOMINAL INVESTMENT TAX CREDIT
  KS0(AI)        CALC    REAL    CAPITAL STOCK
  M0(AI)         IMPLAN  REAL    IMPORTS
  MI0(H)        DOF     REAL    IN MIGRATION
  MO0(H)        DOF     REAL    OUT MIGRATION
  N0(AI)         CALC    REAL    GROSS INVESTMENT BY SECTOR OF DESTINATION
  P0(aZ)         CALC    PRICE   AGGREGATE PRICES
  P0r(C)        Calc    Price   Initial Consumption Price Including tax
  PCTINST(F)    UCB     PERCENT OF EARNINGS RETURNED INSTATE
  PD0(AI)        CALC    PRICE   DOMESTIC PRICES
  PIT0(G,H)     DOF     NOMINAL TAX PER WORKING HOUSEHOLD
  PIT01(G,H)    DOF     NOMINAL TAX PER WORKING HOUSEHOLD
  PVA0(AI)       CALC    PRICE   VALUE ADDED PRICES
  PW0(AI)        CALC    PRICE   EXOGENOUS PRICES IN EXTERNAL MARKETS
  Q0(aZ)         DOF     REAL    SOCIAL ACCOUNTING MATRIX TOTALS
  R0(F,aZ)       IMPLAN  PRICE   INITIAL SECTORAL RENTAL RATE FOR FACTOR
  RA0(F)        IMPLAN  AVERAGE RENTAL RATES FOR FACTORS
  RR0(F,AI)      DOF     PRICE   RENTAL RATES INCLUDING TAXES
  S0(aZ)         DOF     NOMINAL SAVINGS
  SPI0          CALC    NOMINAL STATE PERSONAL INCOME
  TP0(H,G)      DOF     NOMINAL PER ELIGIBLE HOUSEHOLD TRANSFER PAYMENTS
  V0(AI)         IMPLAN  REAL    INTERMEDIATE DEMAND LESS TAXES
  YD0(H)        CALC    NOMINAL AFTER TAX TOTAL HOUSEHOLD INCOMES
  Y0(aZ)         CALC    NOMINAL HOUSEHOLD AND GOVERNMENT INCOMES
  Y20(aZ)        CALC    NOMINAL HOUSEHOLD TRANSFER INCOMES
  YD20(H)       CALC    HOUSEHOLD TRANSFERS
  TAXCRED(GI,H) TAX CREDIT FOR EXPERIMENTS
*
* REGULATORY PARAMETERS
*
  CARBRATE      ARB     TAX ON CARBON DIOXIDE IN BILLION DOLLARS PER MILLION METRIC TONS

  DTPVA(TI,K)   CALC    REAL    PVA FOR TECH K COMPARED TO BASELINE TECH
  LUMP(H,G)     UCB     LUMP SUM PAYMENT FROM G TO H
  MACC(AI,K)     CAT     MARGINAL ABATEMENT COST COEFFICIENT IN BILLION DOLLARS PER MILLION METRIC TONS
  ORDSCEN(T)    CALC    ORDINAL VALUE OF SCENARIO
  ORDVAL(aZ)     CALC    ORDINAL VALUE OF SECTOR PASSED TO REG GMS
  REG1(AI,AJ)     UCB     SCALING OF INTERMEDIATE DEMAND
  REG1_ITK(AI)   CALC    TRACKING OF REG1
  REG11(AJ,TI,K) ARB     PERCENT OFFSET FOR NEW TECH
  REG11_ITK(TI,K) CALC  TRACKING OF REG11
  REG11TRK(AJ,TI,K) CALC TRACKING OF REG11
  REG16(AI,C)    UCB     SCALING OF CONSUMER DEMAND
  REG16TK(AI,C)  CALC    TRACKING OF REG16
  REG16TRK(aZ)   CALC    TRACKING OF REG16
  REG18(aZ,GN)   UCB     SCALING OF GOVERNMENT SPENDING
  REG19(AI,K)    CAT     EMISSION REDUCTION POTENTIAL IN MILLION METRIC TONS PER BILLION DOLLARS OUTPUT
  REG1I_TK(AI)   CALC    TRACKING OF REG1
  REG1TRK(AI,AJ)  CALC    TRACKING OF REG1
  REGYD(H)      UCB     ENVIRONMENTAL BENEFITS ADDED TO YD FOR MIGRATION

  TSEW(TI,K)    CALC    WEIGHT OF EXPONENTIAL TERM IN TSE CALCULATION
  TSEWTSGN(K)   CALC    SIGN ON TSEWTNEG
  TSCALE        UCB     LOGIT PARAMETER   /15/
  oldreg1(AI,AJ)  UCB     REG1 SCENARIO ORDERING CORRECTION
  oldreg16(AI,C) UCB     REG16 SCENARIO ORDERING CORRECTION
  oldreg18(aZ,GN) UCB    REG18 SCENARIO ORDERING CORRECTION
*
  CESDYQTR(H)    UCB    CONSUMER DEMAND ESTIMATION SAMPLE DISPOSABLE INCOME
                        /HOUS1= 6146.17,HOUS2= 6128.889,HOUS4= 6128.889,HOUS6= 13280.21,HOUS8= 13280.21,
                         HOUS9= 13280.21,HOUSH= 13280.21/
  DYQTR0(H)      UCB    DEFLATED QUARTERLY DISPOSABLE INCOME       ;



*
*----------------------------------------------------------------
* 3.3 CALCULATIONS OF PARAMETERS AND INITIAL VALUES
*----------------------------------------------------------------
*
* SENSITIVITY OF MIGRATION TO PUBLIC EDUCATION SPENDING

  ETAED('HOUS1') = 0.5;
  ETAED('HOUS2') = 0.5;
  ETAED('HOUS4') = 0.4;
  ETAED('HOUS6') = 0.3;
  ETAED('HOUS8') = 0.2;
  ETAED('HOUS9') = 0.1;
  ETAED('HOUSH') = 0.1;
*
* POLICY WEIGHTS OF INFRASTRUCURE SPENDING
  KAPPA(GNS) = 1;
*
* FOR SENSITIVITY ANALYSIS EXPERIMENTS
  TAXCRED(GI,H) = 0;
*
* INVESTMENT SUPPLY ELASTICITY
  ETAI(I)       = 20;
*
*
* THE FOLLOWING SIX STEPS COMPRISE A SYSTEMATIC WAY TO BUILD A LARGE MATRIX ( IGTD(G,G) )
* THAT CONTROLS INTER-GOVERNMENTAL TRANSFERS.
*
* STEP 1: 1 = ENDOGENOUS (ALTHOUGH MANY OF THESE ARE RESET IN THE NEXT STEPS)
  IGTD(G,GT) = 1;
*
* STEP 2: 2 = EXOGENOUS
  IGTD(G,'FSNON')  = 2;
  IGTD(G,'CGENF')  = 2;
  IGTD(GC,'CSOTH') = 2;
  IGTD(GL,'LSOTH') = 2;
  IGTD(GL,GC)      = 2;

**
*
* STEP 3: 3 = CA BUDGET BALANCING AND PROP 98 TRANSFERS
  IGTD(GC,'CGENF')      = 3;
  IGTD('LSK14','CGENF') = 3;
*
* STEP 4: 4 = FOR EXOGENOUS TRANSFER PAYMENTS

  IGTD('CSWEL','CGENF') = 4;
  IGTD('LSWEL','CGENF') = 4;

*
* STEP 5: 0 = NOT ALLOWED FOR PAYMENTS BY GOVT SPENDING UNITS TO FACTOR TAXES EXCLUDED

*
  IGTD(GF,GX) = 0;
  IGTD(GF,GN) = 0;
*
**
*
* STEP 6: 0 = NOT ALLOWED IF NOT IN ORIGINAL SAM (SEE MODEL CLOSURE)
  IGTD(G,G1)$( NOT SAM(G,G1) ) = 0;
*
*
* READ IN ELASTICITY AND OTHER KEY PARAMETERS
  ETAE(I)       = MISC(I,'ETAE');
  ETAGS(I)      = 0.1;
  ETAM(I)       = MISC(I,'ETAM');
  SIGMA(I)      = MISC(I,'SIGMA') ;
*  R0('CAPIT',I) = MISC(I,'R0') * 100;
**

  R0('CAPIT',I) = 100 * 0.11;
**
  ETARA(H)      = MISCH(H,'ETARA');
  ETAPIT(H)     = MISCH(H,'ETAPIT');
*  ETATP(H)      = MISCH(H,'ETATP');
**EOM 2/17/09 Initializing ETATP=0
  ETATP(H)      = 0 ;
  ETAYD(H)      = MISCH(H,'ETAYD');
  NRPG(H)       = MISCH(H,'NRPG');
  ETAU(H)       = MISCH(H,'ETAU');
  TAXBASE(G,H)  = MISCG(G,H,'TAXBASE');
  TAXBM(G,H)    = MISCG(G,H,'TAXBM');
  TAXSD(G,H)    = MISCG(G,H,'TAXSD');
  TAXOD(G,H)    = MISCG(G,H,'TAXOD');
  TAXPI(G,H)    = MISCG(G,H,'TAXPI');
*CAPFOR in order to account for row in YEQ
  CAPFOR('CAPIT')  = SAM('ROW','CAPIT');
  CAPFOR('LABOR')  = SAM('ROW','LABOR');
*program calibrates taxcvc to make pit balance exactly
*TAXCVC(G,H)   = MISCG(G,H,'TAXCVC');
  taxcvc(g,h)=0;
  MTR(G,H)      = MISCG(G,H,'MTR');
* READ IN REGULATORY PARAMETER
*
  REG1(I,J)     = 1;
  REG1TRK(I,J)  = 0;
  REG1I_TK(I)   = 0;
  REG1_ITK(I)   = 0;
  REG11TRK(J,TI,K) = 0;
  REG11_ITK(TI,K) = 0;
  REG16(I,C)    = 1;
  REG16TK(I,C)  = 0;
  REG16TRK(Z)   = 0;
  LUMP(H,G)     = 0;
  REGYD(H)      = 0;
  CARBRATE      = 0;
  MACC(I,K)     = 0;
  REG19(I,K)    = 0;
  DTPVA(TI,K)   = 0;
  ORDVAL(aZ)     = ORD(aZ);
  ORDSCEN(T)    = ORD(T);
  REG18(Z,GN) = 1;
  TSEWTSGN(K) = -1;
  TSEWTSGN('1') = 1;
  TSEW(TI,K) = 0.5;
* TIC IS THE COMPLEMENT OF TI IN I.
  TIC(I) = not TI(I);


* K = 1 is the BAU technology, K >0 are additional technologies
  REG11(J,TI,K) = 0;
  REG11(J,TI,'1') = 1;




* Some fraction of carbon tax gets recycled in the state
  PCTINST('CAPIT') = 1.0;
  PCTINST('LABOR') = 0;




* CALCULATE SALES AND EXCISE TAX RATES FROM SAM INFORMATION
  TAUQ(GS,I) = SAM(GS,I) / ( SUM(J, SAM(I,J) ) + SUM(C, SAM(I,C) ) + SUM(G, SAM(I,G) ) + SAM(I,'INVES') );
*Tax base is defined as total sales to be consisten with later usage
*                 - SUM(GS1, SAM(GS1,I) ) );
*

* THEN SET EXPERIMENTAL TAX RATES EQUAL TO INITIAL TAX RATES
  TAUQX(GS,I) = TAUQ(GS,I);
*
* DUTY, FACTOR AND HOUSEHOLD TAXES
  TAUM('FTDUT',I)$(SAM('ROW',I) gt 0) = SAM('FTDUT',I) / SAM('ROW',I);
*  TAUM('FTDUT',I) = SAM('FTDUT',I) / SUM(RW, SAM(RW,I) ) ;
  TAUF(GF,F,I)$(SAM(F,I) AND TAUFF(GF,F)) = SAM(GF,I) / SAM(F,I);
  TAUF(GF,F,G)$(SAM(F,G) AND TAUFF(GF,F)) = SAM(GF,G) / SAM(F,G);
  TAUFX(GF,F,Z) = TAUF(GF,F,Z);
  TAUFH(GF,F)$TAUFF(GF,F) = SAM(GF,F) / SUM(Z, SAM(Z,F));

*
* SET DISTRIBUTION SHARES FOR ENDOGENOUS TAX TRANSFERS
  TAXS(G,GT)$( SUM(G1, SAM(G1,GT) ) - SUM(GF, SAM(GF,GT) ) ) =
  SAM(G,GT) / ( SUM(G1, SAM(G1,GT) ) - SUM(GF, SAM(GF,GT) ) );
*
* SET INITIAL INTER GOVERNMENTAL TRANSFERS
  IGT0(G,G1) = SAM(G,G1);
*factor taxes are not a intergov transfer
  IGT0(GF,G) = 0;
**
*
* SET INITIAL PRICES TO UNITY
  PW0(I)  = 1 / ( 1 + SUM(G, TAUM(G,I) ) );

  P0(I)   = 1 ;



*PHI is industry share and does not include tax share.
  PHI(I,C)      = SAM(I,C) / SUM(Z, SAM(Z,C) );

  TAUC(G,C) = SAM(G,C)/SUM(Z,SAM(Z,C));
  TAUCX(G,C) = TAUC(G,C);
*  p0 is the actual P0 whilst p(C) is an index number p(C)/p0(c);
  P0r(C) =   (SUM(I, PHI(I,C) * P0(I) * ( 1 + SUM(GS, TAUQX(GS,I) ) ) )  ) / (1- sum(G, tauc(g,c)) ) ;
  P0(C) = 1 ;
**EOM 6/30/09 initializing PD0 less taxes to reflect what producers receive
  PD0(I)  = 1;
  CPI0(H) = 1;
*
* NUMBER OF HOUSEHOLDS AND INITIAL TRANSFER PAYMENTS
  HH0(H) = MISCH(H,'HH0');
  HW0(H) = MISCH(H,'HW0');
  HN0(H) = HH0(H) - HW0(H);
  TP0(H,GW)$TPC(H,GW) = SAM(H,GW) / ( HN0(H) * TPC(H,GW) );
*
* FACTOR RENTALS
  JOBCOR  = SUM(H, HW0(H) ) / SUM(Z, MISC(Z,'JOBS') );
display jobcor;
  R0('CAPIT',G) = 1;
  R0('LABOR',I) = SAM('LABOR',I) / MISC(I,'JOBS');
*lingyun R0('LABOR',G) change to fix yfeq not equal at initial point by adjust ccm table
*R0('LABOR',G) = SAM('LABOR',G);
  R0('LABOR',G)$MISC(G,'JOBS') = SAM('LABOR',G) / MISC(G,'JOBS');
  FD0('LABOR',I) = MISC(I,'JOBS');
  FD0('CAPIT',I) = SAM('CAPIT',I) / R0('CAPIT',I);
*lingyun FD0('LABOR',G) change to fix yfeq not equal at initial point
* FD0('LABOR',G) = 1;
  FD0('LABOR',G) = MISC(G,'JOBS');
  FD0('CAPIT',G) = SAM('CAPIT',G) / R0('CAPIT',G);
  KS0(I) = FD0('CAPIT',I);
*
* SHARES FOUND IN THE SOCIAL ACCOUNTING MATRIX DATA
   Q0(Z) = SUM(Z1,SAM(Z,Z1) );
*display Q0;
  A(Z,Z1) = SAM(Z,Z1) / Q0(Z1);
  AG(I,G)$(SUM(J, SAM(J,G) ) + SUM(F, SAM(F,G) ) + SUM(GF, SAM(GF,G) ) )
          =  SAM(I,G) / ( SUM(J, SAM(J,G) ) + SUM(F, SAM(F,G) ) + SUM(GF, SAM(GF,G) ) );
  AG(F,G)$(SUM(I, SAM(I,G) ) + SUM(F1, SAM(F1,G) ) + SUM(GF, SAM(GF,G) ) )
          =  SAM(F,G) / ( SUM(I, SAM(I,G) ) + SUM(F1, SAM(F1,G) ) + SUM(GF, SAM(GF,G) ) );
*
* INITIAL MACRO VARIABLES:
* EXPORTS, IMPORTS, INTERMEDIATES, CONSUMPTION, GOVERNMENT, DEPRECIATION, INVESTMENT, DEMAND, SUPPLY
  CX0(I)   = SAM(I,'ROW');
  M0(I)    = SAM('ROW',I) / PW0(I);
  V0(I)    = SUM(J, SAM(I,J)  / ( 1 + SUM(GS, TAUQX(GS,I) ) )) / P0(I) ;
  CH0(I)   = SUM(C, SAM(I,C)  / ( 1 + SUM(GS, TAUQX(GS,I) ) ) ) / P0(I) ;
  CG0(I,G) = SAM(I,G) / ( 1 + SUM(GS, TAUQX(GS,I) ) ) / P0(I);
*  DEPR     = SUM(I, SAM(I,'INVES') ) / SUM(I, KS0(I) );
  DEPR     = 5 ;
  N0(I)    = KS0(I) * DEPR;
  CN0(I)   = SUM(J, CCM(I,J) * N0(J) ) / ( 1 + SUM(GS, TAUQX(GS,I) ) ) / P0(I) ;
*  DD0(I)   = CH0(I) + SUM(G, CG0(I,G) ) + SAM(I,'INVES')/ ( 1 + SUM(GS, TAUQ(GS,I) ) ) + V0(I);
  DD0(I)   = CH0(I) + SUM(G, CG0(I,G) ) + SAM(I,'INVES') / ( 1 + SUM(GS, TAUQX(GS,I) ) ) / P0(I) + V0(I) ;
  DS0(I)   = DD0(I) + CX0(I) - M0(I);
*
*
* PRODUCTION DATA
  AD(I,J)        = SAM(I,J)  / ( 1 + SUM(GS, TAUQX(GS,I) ) ) / P0(I) / DS0(J);
  ALPHACG(I,GNS) = CG0(I,GNS) / SUM(J, CG0(J,GNS) );
  ALPHAFG(F,GNS) = FD0(F,GNS) / SUM(F1, FD0(F1,GNS) );
**FLAG PVA0
*  PVA0(I)        = PD0(I) - SUM(J, AD(J,I) * P0(J) * ( 1 + SUM(GS, TAUQ(GS,J) ) ) );
  PVA0(I)        = PD0(I) - SUM(J, AD(J,I) * P0(J) * ( 1 + SUM(GS, TAUQX(GS,J) ) ) );
  RA0(F)         = 1;
  E0(I)          = 1;
  GST0           = SUM(GNS, KAPPA(GNS) * ( SUM(J, ALPHACG(J,GNS) * CG0(J,GNS) * P0(J) )
                                       + SUM(F, ALPHAFG(F,GNS) * FD0(F,GNS) * R0(F,GNS) * RA0(F) ) ) );
*
* CARBON TRADING DATA
  CARBON0(I) = SUM(TI, (AD(TI,I) * (DS0(I) )) * CINTENS(TI,I));
*  Until we figure out a way to impose a carbon tax on imports, we better not include imports in calculation of
*  revenue recycling.
*  CARBON0(I) = SUM(TI, (AD(TI,I) * (DS0(I)+ M0(I) - CX0(I))) * CINTENS(TI,I));
*
* MISCELLANEOUS INITIAL DATA

  Y0(F)      = Q0(F);
  Y0(H)      = SUM(F, SAM(H,F) ) ;
  A(H,F)     = SAM(H,F) / HH0(H) / Y0(F);
  TAUH(GH,H) = SAM(GH,H) / HH0(H);
  S0(H)      = SAM('INVES',H);
  YD0(H)     = SUM(C, SAM(C,H) ) + S0(H);
  YD20(H)    = SUM(G, TP0(H,G) * HN0(H) * TPC(H,G)) ;

*savings is the net payments to the rest of the world or to investment
  S0(G)      = SAM('INVES',G)+ SAM('ROW',G)- SAM(G,'INVES') - SAM(G,'ROW');

*TAX income is all sources, less transfers, less exogenous income
  Y0(G)      = SUM(Z, SAM(G,Z) ) - SUM(G1, IGT0(G,G1) )- SAM(G,'INVES') - SAM(G,'ROW');
  Y20(G)     = SUM((I,J), TAUQX(G,I)*(1+sum(gs,tauqx(gs,I) ))  * P0(I) * AD(I,J) * DS0(J) ) + SUM(I, TAUM(G,I) * M0(I) * PW0(I) )
                  + SUM(I, TAUQX(G,I)*(1+sum(gs,tauqx(gs,I) )) * (CH0(I) + CN0(I)) * P0(I) );

  AGI0(H)    = SUM(F, OMEGA(F) * SAM(H,F) ) / HH0(H);
  SPI0       = SUM(H, Y0(H) ) + SUM((H,GW), TP0(H,GW) * HN0(H) * TPC(H,GW) );

  PIT0(GI,H) = SAM(GI,H) / HH0(H);
*
  MIGRFACTOR = 0.09;
  MI0(H)     = MIGRFACTOR * HH0(H);
  MO0(H)     = MIGRFACTOR * HH0(H);
*
* INVESTMENT TAX CREDIT AND CORRECTION TO GROSS CA PROFITS TAXES
  FITC(F,G)                = 0;
  FITC('CAPIT','CTBAC')    = 1;
  ITC0(I)                  = SUM(J, N0(I) * CCM(J,I) / ( 1 + SUM(GS, TAUQX(GS,J) ) ) * ITCE(J,I) );
  TAUF('CTBAC','CAPIT',I)  = ( SAM('CTBAC',I) + ITC0(I) ) / SAM('CAPIT',I);
  TAUFX('CTBAC','CAPIT',I) = TAUF('CTBAC','CAPIT',I);
*
* CES PRODUCTION FUNCTION CALIBRATION
  ALPHA(F,I) = ( SAM(F,I) + SUM(GF, TAUFF(GF,F) * SAM(GF,I) ) ) / ( SUM(F1, SAM(F1,I) ) + SUM(GF, SAM(GF,I) ) );
  RR0(F,I)   = R0(F,I) * RA0(F) * ( 1 + SUM(GF, TAUFX(GF,F,I) ) ) - SUM(GF,  FITC(F,GF) * ITC0(I) ) / FD0(F,I);
*
*
* INITIAL CALIBRATION OF CONSUMPTION FUNCTIONS
  SIGMAH(H)     = SAM('INVES',H) / YD0(H);
  CS0(C,H)      = SAM(C,H) / SUM(C1, SAM(C1,H) );


*
* INITIAL GOVERNMENT SPENDING ON PUBLIC EDUCATION
*  GSED0 = SUM(GED, SUM(G, IGT0(GED,G) ) );
  DYQTR0(H) = CESDYQTR(H) ;


*
*
*----------------------------------------------------------------
* 4. VARIABLES
*----------------------------------------------------------------
* 4.1 VARIABLE DECLARATION
*----------------------------------------------------------------
*
  VARIABLES
*
  AGI(H)    THOUSAND    DOLLARS AVERAGE AGI FOR PIT PURPOSES
  CARBCAP   MILLION     METRIC TONS CARBON DIOXIDE CAP
  CARBON(AI) MILLION     METRIC TONS CARBON DIOXIDE EMISSIONS
  CG(AI,G)   BILLION     DOLLARS PUBLIC CONSUMPTION
  CH(AI)     BILLION     DOLLARS PRIVATE CONSUMPTION LESS SALES AND EXCISE TAXES
  CN(AI)     BILLION     DOLLARS GROSS INVESTMENT BY SECTOR OF SOURCE
  CPI(H)    PRICE       INDEX 1 CONSUMER PRICE INDEX
  CS(C,H)   SHARES      TOTAL 1 CONSUMPTION SHARES OF YD LESS SAVINGS
  CX(AI)     BILLION     DOLLARS EXPORT DEMAND
  DD(AI)     BILLION     DOLLARS DOMESTIC DEMAND
  DS(AI)     BILLION     DOLLARS DOMESTIC SUPPLY
  E(AI)      NUMBER      INFRASTRUCTURE SCALE VARIBALE IN PRODUCTION FUNCTIONS
  FD(F,aZ)   BILLION     DOLLARS SECTORAL FACTOR DEMAND
  GST       BILLION     DOLLARS TOTAL GOVERNMENT SPENDING INCLUDING FACTOR RENTALS
*  GSED      BILLION     DOLLARS TOTAL GOVERNMENT SPENDING ON EDUCATION
  HH(H)     MILLIONS            NUMBER OF HOUSEHOLDS
  HN(H)     MILLIONS            NUMBER OF NONWORKING HOUSEHOLDS
  HW(H)     MILLIONS            NUMBER OF WORKING HOUSEHOLDS
  IGT(G,G1) BILLION     DOLLARS INTER GOVERNMENTAL TRANSFERS
  ITC(AI)    BILLION     DOLLARS INVESTMENT TAX CREDIT AMOUNT
  KS(AI)     100 BILLION DOLLARS CAPITAL STOCK
  M(AI)      BILLION     DOLLARS IMPORTS
  N(AI)      BILLION     DOLLARS GROSS INVESTMENT BY SECTOR OF DESTINATION
*  NKI       BILLION     DOLLARS NET CAPITAL INFLOW
  P(aZ)     PRICE               AGGREGATE DOMESTIC PRICE PAID BY PURCHASERS
  PD(AI)     PRICE               DOMESTIC PRICE RECEIVED BY SUPPLIERS
  PIT(G,H)  THOUSAND    DOLLARS PER HOUSEHOLD INCOME TAXES
  PVA(AI)    PRICE               VALUE ADDED PRICE
  RA(F)     PRICE               ECONOMY WIDE SCALAR RENTAL RATES OF FACTORS
  R(F,aZ)    PRICE               SECTORAL RENTAL RATES
  RR(F,aZ)   PRICE               RENTAL RATES INCLUDING TAXES
  S(aZ)      BILLION     DOLLARS SAVINGS
  SPI       BILLION     DOLLARS STATE PERSONAL INCOME
  TP(H,G)   THOUSAND    DOLLARS GOVERNMENT TRANSFER PAYMENTS
*  TPVA(TI,K) BILLION    PVA FOR TECH K
*  TSE(TI,K) PERCENT     SHARE OF TECH K
*  TSUM(TI)   BILLION    DENOMINATOR OF LOGIT
  V(AI)      BILLION     DOLLARS INTERMEDIATE GOODS LESS TAXES

  VREG1(AI,AJ) PERCENT    COST MINIMIZING CHANGE IN TECHNOLOGY IN USE
  Y(aZ)      BILLION     DOLLARS GROSS INCOMES
  YD(H)     BILLION     DOLLARS AFTER TAX TOTAL HOUSEHOLD INCOMES
  YD2(H)    BILLION     DOLLARS TOTAL HOUSEHOLD TRANSFERS
  Y2(aZ)     BILLION     TRANSFERS
  DYQTR(H)  BILLION     DEFLATED QUARTERLY INCOME
  DP(CC,H)  PRICE       DEFLATED PRICE OF CONSUMPTION GOODS
*  DPR(CNOT,H) PRICE     DEFLATED PRICE OF RESIDUAL GOOD
  PSTAR(H)  PRICE       PRICE INDEX FOR INCOMPLETE DEMAND SYSTEM;
*_________tolerance testing
*  slack(AI)         calc   A slack variable for dd and ds ;

*slack.up(I) = .01;  slack.lo(I) = -.01;



*----------------------------------------------------------------
* 4.2 INITIALIZATION OF VARIABLES
*----------------------------------------------------------------
*
  P.L(Z)      = P0(Z);          PD.L(I)     = PD0(I);          PVA.L(I)    = PVA0(I);        RA.L(F)     = RA0(F);
  R.L(F,Z)    = R0(F,Z);        CPI.L(H)    = CPI0(H);         DS.L(I)     = DS0(I);         DD.L(I)     = DD0(I);
  V.L(I)      = V0(I);          FD.L(F,Z)   = FD0(F,Z);        HH.L(H)     = HH0(H);         HN.L(H)     = HN0(H);
  HW.L(H)     = HW0(H);         KS.L(I)     = KS0(I);          CN.L(I)     = CN0(I);         N.L(I)      = N0(I);
  CX.L(I)     = CX0(I);         M.L(I)      = M0(I);           TP.L(H,G)   = TP0(H,G);         Y2.L(z)     = Y20(Z);
   YD2.L(H)     = YD20(H);
*  NKI.L       = NKI0;
  Y.L(Z)      = Y0(Z);          YD.L(H)     = YD0(H);          PIT.L(G,H)  = PIT0(G,H);      IGT.L(G,G1) = IGT0(G,G1);
  CH.L(I)     = CH0(I);         CG.L(I,G)   = CG0(I,G);        S.L(Z)      = S0(Z);          SPI.L       = SPI0;
  ITC.L(I)    = ITC0(I);        AGI.L(H)    = AGI0(H);         RR.L(F,I)   = RR0(F,I);       CS.L(C,H)   = CS0(C,H);
  E.L(I)      = E0(I);          GST.L      = GST0;
*  GSED.L      = GSED0;
  CARBCAP.L   = SUM(I,CARBON0(I) + (M0(I)-CX0(I)) * TCINTENS(I));
*TSUM.L(TI)  = 1;
* Some variables are not computed for I in TIC.
  CARBON.L(TI) = CARBON0(TI);   CARBON.FX(TIC) = CARBON0(TIC);
$ontext
  TSE.L(TI,'1') = 1;            TSE.UP(TI,K) = 1;             TSE.LO(TI,K) = 0;
$offtext
* VREG is not computed for I in TIC and so is fixed at 1.
*  VREG1.L(I,TI) = 1;    VREG1.FX(I,TIC) = 1;
VREG1.fx(I,J) = 1;
*  DYQTR.L(H) =  ((YD.L(H) * ( 1 - SIGMAH(H) ))/4)/P.L('CRESID')   ;
  DYQTR.L(H) =  DYQTR0(H)   ;
*
*----------------------------------------------------------------
* 4.3 REMOVING TRACE NUMBERS FOR COMPUTATIONAL PURPOSES
*----------------------------------------------------------------
*
  P.L(Z)$(ABS(P.L(Z))           LT 0.00000001) = 0;     PD.L(I)$(ABS(PD.L(I))         LT 0.00000001) = 0;
  PVA.L(I)$(ABS(PVA.L(I))       LT 0.00000001) = 0;     RA.L(F)$(ABS(RA.L(F))         LT 0.00000001) = 0;
  R.L(F,Z)$(ABS(R.L(F,Z))       LT 0.00000001) = 0;     CPI.L(H)$(ABS(CPI.L(H))       LT 0.00000001) = 0;
  DS.L(I)$(ABS(DS.L(I))         LT 0.00000001) = 0;     DD.L(I)$(ABS(DD.L(I))         LT 0.00000001) = 0;
  E.L(I)$(ABS(E.L(I))           LT 0.00000001) = 0;     V.L(I)$(ABS(V.L(I))           LT 0.00000001) = 0;
  FD.L(F,Z)$(ABS(FD.L(F,Z))     LT 0.00000001) = 0;     GST.L$(ABS(GST.L)             LT 0.00000001) = 0;
  HH.L(H)$(ABS(HH.L(H))         LT 0.00000001) = 0;     HN.L(H)$(ABS(HN.L(H))         LT 0.00000001) = 0;
  HW.L(H)$(ABS(HW.L(H))         LT 0.00000001) = 0;     KS.L(I)$(ABS(KS.L(I))         LT 0.00000001) = 0;
  CN.L(I)$(ABS(CN.L(I))         LT 0.00000001) = 0;     N.L(I)$(ABS(N.L(I))           LT 0.00000001) = 0;
  CX.L(I)$(ABS(CX.L(I))         LT 0.00000001) = 0;     M.L(I)$(ABS(M.L(I))           LT 0.00000001) = 0;
*  NKI.L$(ABS(NKI.L)             LT 0.00000001) = 0;
  TP.L(H,G)$(ABS(TP.L(H,G))     LT 0.00000001) = 0;
  Y.L(Z)$(ABS(Y.L(Z))           LT 0.00000001) = 0;     YD.L(H)$(ABS(YD.L(H))         LT 0.00000001) = 0;
  PIT.L(G,H)$(ABS(PIT.L(G,H))   LT 0.00000001) = 0;     IGT.L(G,G1)$(ABS(IGT.L(G,G1)) LT 0.00000001) = 0;
  CH.L(I)$(ABS(CH.L(I))         LT 0.00000001) = 0;     CG.L(I,G)$(ABS(CG.L(I,G))     LT 0.00000001) = 0;
  CG.L(I,G)$(ABS(CG.L(I,G))     LT 0.00000001) = 0;
  S.L(Z)$(ABS(S.L(Z))           LT 0.00000001) = 0;     SPI.L$(ABS(SPI.L)             LT 0.00000001) = 0;
  AGI.L(H)$(ABS(AGI.L(H))       LT 0.00000001) = 0;

*
*----------------------------------------------------------------
* 4.3 SETTING COMPUTATIONALLY USEFUL BOUNDS ON VARIABLES (TO HELP THE SOLVER)
*----------------------------------------------------------------
*
**EOM 6/7/09 activated bounds for AGI,CG,IGT,ITC that were previously commented out
AGI.LO(H)    = AGI0(H)     / 1000;  AGI.UP(H)    = AGI0(H)     * 1000;
CG.LO(I,G)   = CG.L(I,G)   / 1000;  CG.UP(I,G)   = CG.L(I,G)   * 1000;
  CH.LO(I)     = CH.L(I)    / 1000;  CH.UP(I)     = CH.L(I)     * 1000;
  CN.LO(I)     = 0;
  CPI.LO(H)    = CPI.L(H)    / 1000;  CPI.UP(H)    = CPI.L(H)    * 1000;
  CS.LO(C,H)   = CS0(C,H)    / 1000;  CS.UP(C,H)   = 1                 ;
  CX.LO(I)     = CX.L(I)     / 1000;  CX.UP(I)     = CX.L(I)     * 1000;
  DD.LO(I)     = DD.L(I)     / 1000;  DD.UP(I)     = DD.L(I)     * 1000;
  DS.LO(I)     = DS.L(I)     / 1000;  DS.UP(I)     = DS.L(I)     * 1000;
  E.LO(I)      = 0;                   E.UP(I)      = E.L(I)      *    2;
  FD.LO(F,Z)   = FD.L(F,Z)   / 1000;  FD.UP(F,Z)   = FD.L(F,Z)   * 1000;
  GST.LO       = GST.L       / 1000;  GST.UP       = GST.L       * 1000;
  HH.LO(H)     = HH.L(H)     / 1000;  HH.UP(H)     = HH.L(H)     * 1000;
  HN.LO(H)     = HN.L(H)     / 1000;  HN.UP(H)     = HN.L(H)     * 1000;
  HW.LO(H)     = HW.L(H)     / 1000;  HW.UP(H)     = HW.L(H)     * 1000;
IGT.LO(G,G1) = IGT.L(G,G1) / 1000;  IGT.UP(G,G1) = IGT.L(G,G1) * 1000;
ITC.LO(I)    = ITC.L(I)    / 1000;  ITC.UP(I)    = ITC.L(I)    * 1000;
  KS.LO(I)     = KS.L(I)     / 1000;  KS.UP(I)     = KS.L(I)     * 1000;
  M.LO(I)      = M.L(I)      / 1000;  M.UP(I)      = M.L(I)      * 1000;
  N.LO(I)      = 0;
* NKI -- SIGN CAN CHANGE, THUS BOUNDS ARE INAPPROPRIATE
  P.LO(Z)      = P.L(Z)      / 1000;  P.UP(Z)      = P.L(Z)      * 1000;
  PD.LO(I)     = PD.L(I)     / 1000;  PD.UP(I)     = PD.L(I)     * 1000;
  PVA.LO(I)    = PVA.L(I)    / 1000;  PVA.UP(I)    = PVA.L(I)    * 1000;
  R.LO(F,I)    = R.L(F,I)    / 2   ;  R.UP(F,I)    = R.L(F,I)    * 2;
  RA.LO(F)     = RA.L(F)     / 1000;  RA.UP(F)     = RA.L(F)     * 1000;
* S -- SIGN CAN CHANGE, THUS BOUNDS ARE INAPPROPRIATE
  TP.LO(H,G)   = TP.L(H,G)   / 1000;  TP.UP(H,G)   = TP.L(H,G)   * 1000;
  V.LO(I)      = V.L(I)      / 1000;  V.UP(I)      = V.L(I)      * 1000;
  Y.LO(I)      = Y.L(I)      / 1000;  Y.UP(I)      = Y.L(I)      * 1000;
  YD.LO(H)     = YD.L(H)     / 1000;  YD.UP(H)     = YD.L(H)     * 1000;
  RR.LO(F,I)   = RR.L(F,I)   / 1000;  RR.UP(F,I)   = RR.L(F,I)   * 1000;
  DYQTR.LO(H) = DYQTR.L(H)   /1000;  DYQTR.UP(H) = DYQTR.L(H)    * 1000;

* Fixing extraneous variables
P.fx(CP) = 0;
*
* calibrate taxcvc
PIT01(GI,H) = ( TAXBASE(GI,H)+ TAXCVC(GI,H) - TAXCRED(GI,H)
              + ( AGI0(H) - TAXBM(GI,H)
              - TAXSD(GI,H) * (1- TAXPI(GI,H))
              - ( TAXOD(GI,H) + SUM(GI1, ATAX(GI1,GI)
              * PIT.l(GI1,H) ) ) * TAXPI(GI,H) )
              * MTR(GI,H) )  ;
TAXCVC(gi,h)=PIT0(GI,H)-PIT01(GI,H);
PIT01(GI,H) = ( TAXBASE(GI,H)+ TAXCVC(GI,H) - TAXCRED(GI,H)
              + ( AGI0(H) - TAXBM(GI,H)
              - TAXSD(GI,H) * (1- TAXPI(GI,H))
              - ( TAXOD(GI,H) + SUM(GI1, ATAX(GI1,GI)
              * PIT.l(GI1,H) ) )
              * TAXPI(GI,H) ) * MTR(GI,H) )  ;
*
*
*----------------------------------------------------------------
* 5. PRE-MODEL CHECK OF PARAMETERS AND INITIAL VALUES OF VARIABLES
*----------------------------------------------------------------
*Share checking
$batinclude sharecheck.gms
* 5.1 PRINTING CALCULATED PARAMETERS AND EXOGENOUS VARIABLES
*----------------------------------------------------------------
*
*
*----------------------------------------------------------------
* 5.2 SAVING INITIAL VALUES FOR VARIABLES
*----------------------------------------------------------------



*
*
*----------------------------------------------------------------
* 6. EQUATIONS
*----------------------------------------------------------------
* 6.1 EQUATION DECLARATION
*----------------------------------------------------------------
*
  EQUATIONS
*
* HOUSEHOLDS
  CPIEQ(H)      1.01 CONSUMER PRICE INDICES
  YEQ(H)        1.02 HOUSEHOLD GROSS INCOME
  YDEQ(H)       1.03 HOUSEHOLD DISPOSABLE INCOME
  YDEQ2(H)       1.03 HOUSEHOLD TRANSFERS
  CHEQ(AI)       1.05 TOTAL CONSUMPTION OF GOODS AND SERVICES
  CCPEQ(C)      1.06 COMPOSITE COMMODITY PRICES
  SHEQ(H)       1.07 HOUSEHOLD SAVINGS
  DYQEQ(H)      1.08   DEFLATED INCOME
  DPEQ(CC,H)    1.09   DEFLATED PRICE
  PSTAREQ(H)     1.10  IDS PRICE LEVEL
  CSEQ(CC,H)    1.11  CONSUMPTION SHARES BY HOUSEHOLD
  CSEQ2(CC,H)   1.12   CONSUMPTION SHARES BY HOUSEHOLD LOG
  CSEQ3(CNOT,H) 1.13   RESIDUAL SHARE

*
* PRODUCERS
  PVAEQ(AI)      2.01 VALUE ADDED PRICE
  PCEQ(AI)       2.02 COST FUNCTION
  GSTEQ         2.03 TOTAL STATE GOVERNMENT SPENDING
  EEQ(AI)        2.04 INFRASTRUCTURE SCALE VARIABLE
  RREQ(F,AI)     2.05 RENTAL RATES INCLUDING TAXES
  FDEQ(F,AI)     2.06 FACTOR DEMAND
  VEQ(AI)        2.07 DEMAND FOR INTERMEDIATE GOODS BY SOURCE
  YFEQ(F)       2.08 FACTOR INCOME
*  TSUMQ(TI)     2.09 SUM OF EXP OF DIFF IN PVA
*  TSEQ(TI,K)    2.10 LOGIT SHARE
*  TREGQ(J,TI)   2.11 VREG1 AS FUNCTION OF REG11 AND SHARE
  CARBEQ(TI)    2.12 CARBON TRADING
  CCAPEQ        2.13 CARBON CAP
*
* TRADE
  XEQ(AI)        3.01 EXPORT DEMAND
  MEQ(AI)        3.02 IMPORT SUPPLY
  PEQ(AI)        3.03 AVERAGE PRICE FACED BY DOMESTIC CONSUMPTION

*
* INVESTMENT
  NEQ(AI)        4.01 INVESTMENT BY SECTOR OF DESTINATION
  CNEQ(AI)       4.02 INVESTMENT BY SECTOR OF SOURCE
  KSEQ(AI)       4.03 DESIRED CAPITAL STOCK
  ITCEQ(AI)      4.04 INVESTMENT TAX CREDIT EARNED
*
* LABOR SUPPLY AND MIGRATION
  LSEQ(H)       5.01 LABOR SUPPLY
  POPEQ(H)      5.02 MIGRATION
  ANEQ(H)       5.03 NUMBER OF NON-WORKING HOUSEHOLDS
*
* HOUSEHOLD INCOME TAXATION
  AGIEQ(H)      6.01 ADJUSTED GROSS INCOMES
  PITEQ(GI,H)   6.02 INCOME TAXES
*
* GOVERNMENT
  YGEQ(G)       7.01 GOVERNMENT TAX INCOMES
  YGEQ2(G)      7.015  TRANSFERS
  CGNEQ(AI,GN)   7.02 ENDOGENOUS GOVERNMENT CONSUMPTION
  GFNEQ(F,GN)   7.03 ENDOGENOUS GOVERNMENT FACTOR RENTALS
  CGXEQ(AI,GX)   7.04 EXOGENOUS GOVERNMENT CONSUMPTION
  GFXEQ(F,GX)   7.05 EXOGENOUS GOVERNMENT FACTOR RENTALS
  TDEQ(G,GT)    7.06 DISTRIBUTION OF TAX REVENUES TO SPENDING DESTINATIONS
**PB
*  TDEQ2(G,GT)   7.065 DISTRIBUTION OF ALL REVENUES FOR CTREG TO SPENDING DESTINATIONS
  TPGTEQ(GW,G1) 7.07 IGT FOR TRANSFER PAYMENTS
  GFBALEQ       7.08 BALANCE OF GENERAL FUND TO WELFARE PAYMENTS
  GSEQ(G)       7.09 GOVERNMENT SAVINGS
* PROP98        7.10 PROPOSITION 98 TRANSFER FOR EDUCATION -- TEST 2
  PROP98        7.11 PROPOSITION 98 TRANSFER FOR EDUCATION -- TEST 3
*  GSEDEQ        7.12 EDUCATION SPENDING
*
* MODEL CLOSURE
  SPIEQ         8.01 ARTIFICIAL OBJECTIVE FUNCTION -- TOTAL STATE PERSONAL INCOMES
  LMEQ          8.02 LABOR MARKET EQUILIBRIUM
  KMEQ(AI)       8.03 CAPITAL MARKETS EQUILIBRIUM
  GMEQ(AI)       8.04 GOODS AND SERVICES MARKETS EQUILIBRIUM
  DDEQ(AI)       8.05 DOMESTIC DEMAND DEFINITION;

*
* FOR REFERENCE PURPOSES THE FOLLOWING ARE LISTED ALONG WITH EQUATIONS,
* ALTHOUGH THE GAMS SPECIFICATION OF FIXING VARIABLES TO LEVELS
* WAS USED FOR ITS COMPUTATIONAL PROPERTIES
*
*               9.01 FIX PIT FOR NON INCOME TAX UNITS TO ZERO
*               9.02 FIX INTER GOVERNMENTAL TRANSFERS TO ZERO IF NOT IN ORIGINAL SAM
*               9.03 FIX EXOGENOUS INTERGOVERNMENTAL TRANSFERS
*               9.04 FIX GOVERNMENT DEMAND FOR GOODS AND SERVICES TO ZERO IF NOT IN ORIGINAL DATA
*               9.05 FIX GOVERNMENT DEMAND FOR FACTORS TO ZERO IF NOT IN ORIGINAL DATA
*               9.06 FIX INTER SECTORAL WAGE DIFFERENTIALS
*               9.07 FIX GOVERNMENT RENTAL RATE FOR CAPITAL TO INITIAL LEVEL
*               9.08 FIX ECONOMY WIDE SCALAR FOR CAPITAL
*               9.09 FIX EXOGENOUS TRANSFER PAYMENT LEVELS
*               9.10 FIX TRANSFER PAYMENTS TO ZERO IF NOT IN ORIGINAL DATA
*
*----------------------------------------------------------------
* 6.2 EQUATION ASSIGNMENT
*----------------------------------------------------------------
*
*----------------------------------------------------------------
* 6.2.1 HOUSEHOLDS
*----------------------------------------------------------------
*
*  1.01 CONSUMER PRICE INDICES
* pb feb 17:  P(C) is a price index, it is 1 in base.
  CPIEQ(H).. LOG( CPI(H) ) =E= SUM(C, CS(C,H) * LOG( P(C) ) );
*  CPIEQ(H)..  CPI(H)  =E= SUM(C, CS0(C,H) *  P(C)  );
*
*  1.02 HOUSEHOLD GROSS INCOME

**LUMP is the carbon tax yield returned in a lump sum.   Capfor('labor') = 0 and taufh(g,'capit) = 0;
  YEQ(H).. Y(H) =E= SUM(F, A(H,F) * HH(H) / SUM(H1, A(H1,F) * HH(H1) )* (Y(F)-CAPFOR(F))* ( 1 - SUM(G, TAUFH(G,F) ) ) )
                    + SUM(G,LUMP(H,G));


*
*  1.03 HOUSEHOLD DISPOSABLE INCOME
  YDEQ(H).. YD(H) =E= Y(H) - SUM(GI, PIT(GI,H) ) * HH(H) - SUM(G, TAUH(G,H) * HH(H) ) +
                                          SUM(G, TP(H,G) * HN(H) * TPC(H,G) );
*  1.04  NOT USED
*
*  1.05 TOTAL CONSUMPTION OF GOODS AND SERVICES BY HOUSEHOLDS
*

  CHEQ(I).. P(I)*CH(I) =E= SUM(C, REG16(I,C) *PHI(I,C) *
                      SUM(H, CS(C,H) * ( YD(H) - S(H) ) ) ) /( 1 + SUM(GS, TAUQX(GS,I) ) ) ;




*
*  1.06 COMPOSITE COMMODITY PRICES
*After tax p(c) is normalized to be 1 in base.
*
*  CCPEQ(C).. P(C) =E=   SUM(I, REG16(I,C) *PHI(I,C) * P(I) *(1 + SUM(GT, TAUC(GT, C) ) ) / ( 1 - SUM(GS, TAUQX(GS,I) ) ) )
*                        / SUM(I, PHI(I,C) * P0(I) * (1 + SUM(GT, TAUC(GT, C) ) )*( 1 + SUM(GS, TAUQ(GS,I) ) ));

*  pb feb 17 P(C) is a price index relative to base P0(c).
 CCPEQ(C).. P0r(C) *P(C) =E=   SUM(I, REG16(I,C) *PHI(I,C) * P(I) * ( 1 + SUM(GS, TAUQX(GS,I) ) ) )   /
                                      (1- SUM(G,TAUCX(G,C)) ) ;

*
*  1.07 HOUSEHOLD SAVINGS
*
  SHEQ(H).. S(H) =E=  SIGMAH(H) * YD(H);
*  1.08 HOUSEHOLD TOTAL TRANSFERS
*
  YDEQ2(H).. YD2(H) =E=   SUM(G, TP(H,G) * HN(H) * TPC(H,G)) ;
*
*  1.08
* normalize to ces values
**

  DYQEQ(H).. DYQTR(H) =E=  YD(H) / P('CRESID') * CESDYQTR(H) / YD0(H)  ;
*dyqeq(h).. dyqtr(h) =E= dyqtr0(h);
*dyqtr.fx(h) = dyqtr0(h);

*  1.09
*
  DPEQ(CC,H) .. DP(CC,H) =E= ((P(CC)/P('CRESID'))**lambda(H) - 1)/lambda(H)   ;
*dpeq(cc,h) .. dp(cc,h) =E= 0;
*dp.fx(cc,h) = 0;

*  1.10
*
  PSTAREQ(H).. PSTAR(H) =E= sum(CC,alfa(CC,H)*DP(CC,H)) + .5* sum(CC1,sum(CC2, DP(CC1,H)*DP(CC2,H)*gamma(H,CC1,CC2)))   ;

*  PSTAREQ(H) .. PSTAR(H) =E= 0 ;
*   pstar.fx(h) = 0;

*  1.11       Share equations for extended AIDS
*
$ontext
  CSEQ(CC,H)$kapp(H) ..   CS(CC,H) =E= ( DYQTR(H)**(-kapp(H)) * (P(CC)/P('CRESID'))**(lambda(H)) *
        ( alfa(CC,H) + sum(CC1,gamma(H,CC,CC1)*DP(CC,H)) + beta(CC,H) * ( (DYQTR(H)**kapp(H) - 1)/kapp(H)  - PSTAR(H))) )
          - Cdiffsss(CC,H);
  CSEQ2(CC,H)$(kapp(H)=0) ..   CS(CC,H) =E= ( DYQTR(H) * (P(CC)/P('CRESID'))**(lambda(H)) *
         ( alfa(CC,H) + sum(CC1,gamma(H,CC,CC1)*DP(CC,H)) + beta(CC,H) * ( log(DYQTR(H))  - PSTAR(H) ) ) )
          / DYQTR(H)
          - Cdiffsss(CC,H);
$offtext
*$ontext
  CSEQ(CC,H)$kapp(H) ..   CS(CC,H) =E=  cs0(cc,h);

*  1.12
*

  CSEQ2(CC,H)$(kapp(H)=0) ..   CS(CC,H) =E= CS0(CC,H) ;
*$offtext
*

*
*  1.13   Shares add up to 1
*
  CSEQ3(CNOT,H).. CS(CNOT,H) =E= 1 - sum(CC,CS(CC,H));

*----------------------------------------------------------------
* 6.2.2 PRODUCERS
*----------------------------------------------------------------
*
*  2.01 VALUE ADDED PRICE
*

  PVAEQ(I).. PVA(I) =E= PD(I)
                        - SUM(J, AD(J,I) * REG1(J,I) * VREG1(J,I) * P(J) * ( 1 + SUM(GS, TAUQX(GS,J) ) ) )
                        - SUM(J, AD(J,I) * REG1(J,I) * VREG1(J,I) * CINTENS(J,I) * CARBRATE) ;
$ontext
                        + SUM(TI$(ORDVAL(TI) EQ ORDVAL(I)),SUM(K$(SUM(J,REG11(J,TI,K))gt 0),TSE(TI,K)*REG19(TI,K))) *
                             CARBRATE;
$offtext

*
*  2.02 UNIT COST FUNCTION
*
  PCEQ(I).. PVA(I) =E= 1 / E(I) * PVA0(I) *
                        SUM(F, ALPHA(F,I) * ( RR(F,I) / RR0(F,I) ) ** ( 1 - SIGMA(I) ) ) ** ( 1 / ( 1 - SIGMA(I) ) );
*
* 2.03 TOTAL GOVERNMENT SPENDING (CONSUMPTION SPENDING AND FACTOR RENTAL)
*
  GSTEQ.. GST =E= SUM(GNS, KAPPA(GNS) *
                  ( SUM(J, ALPHACG(J,GNS) * CG(J,GNS) * P0(J) ) +
                           SUM(F, ALPHAFG(F,GNS) * FD(F,GNS) * R0(F,GNS) * RA0(F) ) ) );
*
* 2.04 INFRASTRUCTURE VARIABLE
*
  EEQ(I).. E(I) =E= E0(I);
* * ( GST / GST0 ) ** ETAGS(I);
** use above line to implement infrastructure experiments
* 2.05 RENTAL RATES INCLUDING TAXES
*
  RREQ(F,I).. RR(F,I) =E= R(F,I) * RA(F) * ( 1 + SUM(GF, TAUFX(GF,F,I) ) ) - SUM(GF, FITC(F,GF) * ITC(I) ) / FD(F,I);
*
* 2.06 FACTOR DEMAND
*
  FDEQ(F,I).. FD(F,I) =E= E(I) * FD0(F,I) * DS(I) / DS0(I) *
                          ( ( RR0(F,I) * PVA(I) ) / ( RR(F,I) * PVA0(I) ) ) ** SIGMA(I);
*
* 2.07 DEMAND FOR INTERMEDIATE GOODS BY SOURCE
*
 VEQ(I).. V(I) =E= SUM(J, AD(I,J) * REG1(I,J) * VREG1(I,J) * DS(J) );

*
* 2.08 FACTOR INCOME
*

** Includes carbon tax recycling from in-state and imports, by Peter Berck Aug 17, 2007
  YFEQ(F).. Y(F) =E= SUM(Z,   R(F,Z) * RA(F)* FD(F,Z) ) + CARBRATE * PCTINST(F) * SUM(I,CARBON(I))
             + SUM(I,(M(I)-CX(I)) * PW0(I) *TCINTENS(I) * CARBRATE * PCTINST(F));
$ontext
*
* 2.09 SUM OF EXP OF DIFF IN PVA
*
  TSUMQ(TI).. TSUM(TI) =E= SUM(K$(SUM(J,REG11(J,TI,K))gt 0),
                                                           TSEW(TI,K) * EXP(DTPVA(TI,K) * TSCALE) +
                                                           TSEWTSGN(K) *
                                                           (1-TSEW(TI,K)) * EXP(DTPVA(TI,'1')*TSCALE));
*
* 2.10 LOGIT SHARE
*
  TSEQ(TI,K)$(SUM(J,REG11(J,TI,K))gt 0) .. TSE(TI,K) =E= (TSEW(TI,K) * EXP(DTPVA(TI,K) * TSCALE) +
                                                          TSEWTSGN(K) *
                                                          (1-TSEW(TI,K)) * EXP(DTPVA(TI,'1') * TSCALE)) /
                                                         TSUM(TI);
*
* 2.11 VREG1 AS FUNCTION OF REG11 AND SHARE
*
  TREGQ(J,TI)..  VREG1(J,TI) =E=  SUM(K,REG11(J,TI,K)*TSE(TI,K));
$offtext
*
* 2.12 CARBON TRADING
*
  CARBEQ(TI).. CARBON(TI) =E= SUM(J,(AD(J,TI) * (REG1(J,TI)*VREG1(J,TI)*DS(TI) )) * CINTENS(J,TI))   ;
$ontext
                            - DS(TI) * SUM(K$(SUM(J,REG11(J,TI,K))gt 0),TSE(TI,K)*REG19(TI,K));
$offtext
*
* 2.13 CARBON CAP
*
*  CCAPEQ.. CARBCAP =E= SUM(I,CARBON(I)) + SUM(I,(M(I)-CX(I)) * TCINTENS(I));
  CCAPEQ.. CARBCAP =E= SUM(I,CARBON(I) + (M(I)-CX(I)) * TCINTENS(I));
*
*
*----------------------------------------------------------------
* 6.2.3 TRADE
*----------------------------------------------------------------
*
* 3.01 EXPORT DEMAND
* original
  XEQ(I).. CX(I) =E= CX0(I) * ( PD(I) / PD0(I) ) ** ETAE(I);
* august 17 carb tax for trade
*  XEQ(I).. CX(I) =E= CX0(I) * ( (PD(I)/(PW0(I) * (1+ TCINTENS(I) * CARBRATE))) / (PD0(I)/PW0(I)) ) ** ETAE(I);
*
* Bill Dean, Peter Berck, Winnie Kam, April 27, 2007.
* We replaced the import elasticities in MSC120.gms with Armington elasticities.
* Also we modified the export import equation by including DD/DD0.
* 3.02 IMPORT SUPPLY
*
*  MEQ(I).. M(I)* DD0(I) =E= DD(I) * M0(I) * ( (PD(I)/(PW0(I) * ( 1 + TCINTENS(I) * CARBRATE) ) ) / ( PD0(I)/PW0(I) ) ) ** ETAM(I);
  MEQ(I).. M(I) =E=  M0(I) * ( (PD(I)/(PW0(I) * ( 1 + TCINTENS(I) * CARBRATE) ) ) / ( PD0(I)/PW0(I) ) ) ** ETAM(I);
*   MEQ(I).. M(I) =E= M0(I) ;

*

* 3.03 AVERAGE PRICE FACED BY DOMESTIC CONSUMPTION
*
  PEQ(I).. P(I) =E= ( ( DS(I) - CX(I) ) * PD(I) +
                      M(I) * PW0(I) *(1 + TCINTENS(I) * CARBRATE) * ( 1 + SUM(G, TAUM(G,I) ) ) ) /
                    ( DS(I) - CX(I) + M(I) );
*

*

*
* 3.04 NET CAPITAL INFLOW

*----------------------------------------------------------------
* 6.2.4 INVESTMENT
*----------------------------------------------------------------
*
* 4.01 INVESTMENT BY SECTOR OF DESTINATION
*
  NEQ(I).. N(I) =E= KS(I) * DEPR;
*
* 4.02 INVESTMENT BY SECTOR OF SOURCE
*
*  CNEQ(I).. P(I) * ( 1 + SUM(GS, TAUQX(GS,I) ) ) * CN(I) =E= SUM(J, CCM(I,J) * N(J) );
*
  CNEQ(I).. P(I) * CN(I) * ( 1 + SUM(GS, TAUQX(GS,I) ) ) =E= SUM(J, CCM(I,J) * N(J) );
*
* 4.03 DESIRED CAPITAL STOCK
*
  KSEQ(I).. KS(I) =E= KS0(I) * ( R('CAPIT',I) / R0('CAPIT',I) ) ** ETAI(I);
*
* 4.04 INVESTMENT TAX CREDIT EARNED
*
*  ITCEQ(I).. ITC(I) =E= SUM(J, N(I) * CCM(J,I) / ( 1 + SUM(GS, TAUQX(GS,J) ) ) * ITCE(J,I) );
*
  ITCEQ(I).. ITC(I) =E= SUM(J, N(I) * CCM(J,I) / ( 1 + SUM(GS, TAUQX(GS,J) ) ) * ITCE(J,I) );
*
*----------------------------------------------------------------
* 6.2.5 LABOR SUPPLY AND MIGRATION
*----------------------------------------------------------------
*
* 5.01 LABOR SUPPLY
*
  LSEQ(H).. HW(H) / HH(H) =E= HW0(H) / HH0(H)
        * ( ( RA('LABOR') / RA0('LABOR') ) / ( CPI(H) / CPI0(H) ) ) ** ETARA(H)
        * ( SUM(GI, PIT(GI,H) ) / SUM(GI, PIT0(GI,H) ) ) ** ETAPIT(H)
        * ( SUM(G, TP(H,G) / CPI(H) )  / SUM(G, TP0(H,G) / CPI0(H) ) ) ** ETATP(H);

* 5.02 MIGRATION
*
*$ONTEXT
  POPEQ(H).. HH(H) =E= HH0(H) * NRPG(H)
                       + MI0(H) * ( ( (YD(H)+REGYD(H)) / HH(H) )
                                / ( YD0(H) / HH0(H) ) / ( CPI(H) / CPI0(H) ) ) ** ETAYD(H)
                                * ( ( HN(H) / HH(H) ) / ( HN0(H) / HH0(H) ) ) ** ETAU(H)
                       - MO0(H) * ( ( YD0(H) / HH0(H) ) / ( (YD(H)+REGYD(H)) / HH(H) )
                                / ( CPI0(H) / CPI(H) ) ) ** ETAYD(H)
                                * ( ( HN0(H) / HH0(H) ) / ( HN(H) / HH(H) ) ) ** ETAU(H) ;
*$OFFTEXT
* POPEQ(H).. HH(H) =E= HH0(H) * NRPG(H)-2.5*0.025*(HN(H)-HN0(H))     ;

*
* 5.03 NUMBER OF NON-WORKING HOUSEHOLDS
*
  ANEQ(H).. HN(H) =E= HH(H) - HW(H);
*
*----------------------------------------------------------------
* 6.2.6 HOUSEHOLD INCOME TAXATION
*----------------------------------------------------------------
*
* 6.01 ADJUSTED GROSS INCOMES
*LINGYUN CHANGE HW TO HH  LINGYUN ADD CAPFOR TO FIX AGIEQ
  AGIEQ(H).. AGI(H) =E= SUM(F, A(H,F) * HH(H) / SUM(H1, A(H1,F) * HH(H1) )
                        * OMEGA(F) * (Y(F) - CAPFOR(F)) * ( 1 - SUM(G, TAUFH(G,F) ) ) ) / HH(H);
*
* 6.02 INCOME TAXES
PITEQ(GI,H).. PIT(GI,H) =E=  TAXBASE(GI,H) + TAXCVC(GI,H)  - TAXCRED(GI,H) +
                               ( AGI(H) - TAXBM(GI,H)
                                - TAXSD(GI,H)  *(1- TAXPI(GI,H))
                              - ( TAXOD(GI,H) + SUM(GI1, ATAX(GI1,GI) * PIT(GI1,H) ) ) * TAXPI(GI,H) )
                                 * MTR(GI,H)  ;

*
*----------------------------------------------------------------
* 6.2.7 GOVERNMENT
*----------------------------------------------------------------
*
* 7.01 GOVERNMENT TAX INCOMES

*
YGEQ(G).. Y(G) =E=
                 SUM(I,  TAUQX(G,I) * V(I) * P(I) * ( 1 + SUM(GS, TAUQx(GS,I) ) ) )
               + SUM(I,      TAUM(G,I) * M(I) * PW0(I) )
               + SUM(I,      TAUQX(G,I) * CH(I) * P(I) * ( 1 + SUM(GS, TAUQx(GS,I) ) ) )
               + SUM(I,      TAUQX(G,I) * CN(I) * P(I) * ( 1 + SUM(GS, TAUQx(GS,I) ) ) )
               + SUM((G1,I), TAUQX(G,I) * CG(I,G1) * P(I) * ( 1 + SUM(GS, TAUQx(GS,I) ) ) )
               + SUM((F,I),  TAUFX(G,F,I) * RA(F) * R(F,I)  * FD(F,I) )
               + SUM((F,G1), TAUFX(G,F,G1) * RA(F) * R(F,G1) * FD(F,G1) )
               + SUM(F,      TAUFH(G,F) * Y(F) )
               + SUM(H,      PIT(G,H) * HH(H) )
               + SUM(H,      TAUH(G,H) * HH(H) )
               - SUM((I,F),  FITC(F,G) * ITC(I))
               - SUM(H,LUMP(H,G))
               + SUM(C, TAUC(G, C) * (SUM(H, CS(C,H) * ( YD(H) - S(H) ) ) ) ) ;

* 7.015 GOVERNMENT TRANSFERS
*
*~KA estimate GSP June08
  YGEQ2(G).. Y2(G) =E=   SUM((I,J),  TAUQX(G,I)*(1+sum(gs,tauqx(gs,I) )) * P(I) * REG1(I,J) *
                              VREG1(I,J) * AD(I,J) * DS(J) )
                       + SUM(I,      TAUM(G,I) * M(I) * PW0(I) )
                       + SUM(I,      TAUQX(G,I)*(1+sum(gs,tauqx(gs,I) ) )* CH(I) * P(I) )
                       + SUM(I,      TAUQX(G,I) *(1+sum(gs,tauqx(gs,I) ))* CN(I) * P(I) )
                 ;


*
*
*
* 7.02 ENDOGENOUS GOVERNMENT CONSUMPTION
* Gov't income is Net transfers to gov; less net transfers to HH;
* less all exogenous payments to and from outsiders and investment;
* plus income from taxation.
*
*
*  CGNEQ(I,GN).. P(I) * ( 1 + SUM(GS, TAUQX(GS,I) ) ) * CG(I,GN)
*                    =E= AG(I,GN) * REG18(I,GN) * ( SUM(G, IGT(GN,G) - IGT(G,GN) ) - SUM(H, TP(H,GN) * HN(H) * TPC(H,GN) )
*                        - S0(GN) + Y(GN) );
  CGNEQ(I,GN)..   P(I) * CG(I,GN) * ( 1 + SUM(GS, TAUQX(GS,I) ) )
                    =E= AG(I,GN) * REG18(I,GN) * ( SUM(G, IGT(GN,G) - IGT(G,GN) ) - SUM(H, TP(H,GN) * HN(H) * TPC(H,GN) )
                        - S0(GN) + Y(GN) );
*
* 7.03 ENDOGENOUS GOVERNMENT FACTOR RENTALS
**pb as in 7.02
*
  GFNEQ(F,GN)$FD0(F,GN).. FD(F,GN) * R(F,GN) * RA(F)
                    =E= AG(F,GN) * REG18(F,GN) * ( SUM(G, IGT(GN,G) - IGT(G,GN) ) - SUM(H, TP(H,GN) * HN(H) * TPC(H,GN) )
                        - S0(GN) + Y(GN) );
*
*
* 7.04 EXOGENOUS GOVERNMENT CONSUMPTION
*
*  CGXEQ(I,GX).. P(I) * ( 1 + SUM(GS, TAUQX(GS,I) ) ) * CG(I,GX) =E= P0(I) * ( 1 + SUM(GS, TAUQ(GS,I)  ) ) * CG0(I,GX);
*
  CGXEQ(I,GX).. P(I) * CG(I,GX) * ( 1 + SUM(GS, TAUQX(GS,I) ) )  =E= P0(I) * CG0(I,GX) * ( 1 + SUM(GS, TAUQX(GS,I)  ) ) ;
*
* 7.05 EXOGENOUS GOVERNMENT FACTOR RENTALS
*
  GFXEQ(F,GX).. FD(F,GX) * R(F,GX) * RA(F) =E= FD0(F,GX) * R0(F,GX) * RA0(F);
*
* 7.06 DISTRIBUTION OF TAX REVENUES TO SPENDING DESTINATIONS
*
  TDEQ(G,GT)$(IGTD(G,GT) EQ 1).. IGT(G,GT) =E= TAXS(G,GT) * Y(GT);
*
*
* 7.07 DISTRIBUTION FROM SOURCES OF TRANSFER PAYMENTS
* Only for sectors that pay only transfer payments
*
*  TPGTEQ(GW,G1)$(IGTD(GW,G1) EQ 4).. IGT(GW,G1) =E= IGT0(GW,G1) + SUM(H, HN(H)  * TP(H,GW)  * TPC(H,GW) )
*                                                                - SUM(H, HN0(H) * TP0(H,GW) * TPC(H,GW) );
  TPGTEQ('LSWEL',G1)$(IGTD('LSWEL',G1) EQ 4).. IGT('LSWEL',G1) =E= IGT0('LSWEL',G1) + SUM(H, HN(H)  * TP(H,'LSWEL')  * TPC(H,'LSWEL') )
                                                                - SUM(H, HN0(H) * TP0(H,'LSWEL') * TPC(H,'LSWEL') );

*
* 7.08 BALANCE OF GENERAL FUND SPREAD EVENLY AMONGST GENERAL FUND UNITS

*
  GFBALEQ(GC).. IGT(GC,'CGENF') =E= ( Y('CGENF') + SUM(G, IGT('CGENF',G) ) - SUM(GL, IGT(GL,'CGENF') ) - S0('CGENF') )
                                     * SAM(GC,'CGENF') / SUM(GC1, SAM(GC1,'CGENF') );
* 7.09 GOVERNMENT SAVINGS
*
*
*  GSEQ(G).. S(G) =E= Y(G) + SUM(G1, IGT(G,G1) - IGT(G1,G) ) - SUM(H, TP(H,G) * HN(H) * TPC(H,G) )
*                          - SUM(I, CG(I,G) * P(I) * ( 1 + SUM(GS, TAUQX(GS,I) ) ) )
*                          - SUM(F, FD(F,G) * R(F,G) * RA(F) * ( 1 + SUM(GF, TAUFX(GF,F,G) ) ) );
*
  GSEQ(G).. S(G) =E= Y(G) + SUM(G1, IGT(G,G1) - IGT(G1,G) ) - SUM(H, TP(H,G) * HN(H) * TPC(H,G) )
                          - SUM(I, CG(I,G) * P(I) * ( 1 + SUM(GS, TAUQX(GS,I) ) ) )
                          - SUM(F, FD(F,G) * R(F,G) * RA(F) * ( 1 + SUM(GF, TAUFX(GF,F,G) ) ) );
*
* 7.10 PROPOSITION 98 TRANSFER FOR EDUCATION -- TEST 2
*
* PROP98.. IGT('LSK14','CGENF')
*            =E=  IGT0('LSK14','CGENF') * ADA
*               * ( SUM(H, Y(H)  + SUM(G, TP(H,G)  * HN(H)  * TPC(H,G) ) ) / SUM(H, HH(H)  ) )
*               / ( SUM(H, Y0(H) + SUM(G, TP0(H,G) * HN0(H) * TPC(H,G) ) ) / SUM(H, HH0(H) ) ) ;
*
* 7.11 PROPOSITION 98 TRANSFER FOR EDUCATION -- TEST 3
*
  PROP98.. IGT('LSK14','CGENF')
             =E= IGT0('LSK14','CGENF') * ADA
             * ( ( Y('CGENF')  + SUM(G, IGT('CGENF',G)  ) ) / SUM(H, HH(H)  ) )
             / ( ( Y0('CGENF') + SUM(G, IGT0('CGENF',G) ) ) / SUM(H, HH0(H) ) );
*
*
* 7.12 PUBLIC EDUCATION SPENDING
*
*  GSEDEQ.. GSED =E= SUM(GED, SUM(G, IGT(GED,G) ) );
*
*----------------------------------------------------------------
* 6.2.8 MODEL CLOSURE
*----------------------------------------------------------------
*
* 8.01 ARTIFICIAL OBJECTIVE FUNCTION -- TOTAL STATE PERSONAL INCOMES
*
*   SPIEQ.. SPI =E= SUM(H, ( Y(H) + SUM(G, TP(H,G) * HN(H) * TPC(H,G) ) ) / CPI(H) );
*   SPIEQ.. SPI =E= SUM(H, Y(H)/CPI(H)) + SUM((H,G), (TP(H,G) * HN(H) * TPC(H,G) ) / CPI(H) );
   SPIEQ.. SPI =E= SUM(H, ( Y(H) + SUM(G, TP(H,G) * HN(H) * TPC(H,G) ) ) );
*
* 8.02 LABOR MARKET EQUILIBRIUM
*
  LMEQ.. SUM(H, HW(H) ) =E= SUM(Z, FD('LABOR',Z) ) * JOBCOR;
*
* 8.03 CAPITAL MARKETS EQUILIBRIUM
*
  KMEQ(I).. KS(I) =E= FD('CAPIT',I);
*
* 8.04 GOODS AND SERVICES MARKETS EQUILIBRIUM
*
  GMEQ(I).. DS(I) =E= DD(I) + CX(I) - M(I);
*
* 8.05 DOMESTIC DEMAND DEFINITION
*
  DDEQ(I).. DD(I) =E= V(I) + CH(I) + SUM(G, CG(I,G) ) + CN(I);
*DDEQ(I).. P(I) =E= P0(I);
*

*
*----------------------------------------------------------------
* 6.29 MODEL CLOSURE USING FIXED VALUES (COMPUTATIONALLY MORE EFFICIENT THAN EQUATIONS)
*----------------------------------------------------------------
*
* 9.01 FIX PIT FOR NON INCOME TAX UNITS TO ZERO
*
  PIT.FX(G,H)$(NOT GI(G)) = 0;
*
* 9.02 FIX INTER GOVERNMENTAL TRANSFERS TO ZERO IF NOT IN ORIGINAL SAM
*
  IGT.FX(G,G1)$(NOT IGTD(G,G1)) = 0;
*
* 9.03 FIX EXOGENOUS INTERGOVERNMENTAL TRANSFERS
*
  IGT.FX(G,G1)$(IGTD(G,G1) EQ 2) = IGT0(G,G1);
*
* 9.04 FIX GOVERNMENT DEMAND FOR GOODS AND SERVICES TO ZERO IF NOT IN ORIGINAL DATA
*
  CG.FX(I,G)$(NOT SAM(I,G) ) = 0;
*
* 9.05 FIX GOVERNMENT DEMAND FOR FACTORS TO ZERO IF NOT IN ORIGINAL DATA
*
  FD.FX(F,G)$(NOT SAM(F,G) ) = 0;
*
* 9.06 FIX INTER SECTORAL WAGE DIFFERENTIALS
*
  R.FX('LABOR',Z) = R0('LABOR',Z);
*
* 9.07 FIX GOVERNMENT RENTAL RATE FOR CAPITAL TO INITIAL LEVEL
*
  R.FX('CAPIT',G) = R0('CAPIT',G);
*
* 9.08 FIX ECONOMY WIDE SCALAR FOR CAPITAL
*
  RA.FX('CAPIT') = RA0('CAPIT');
*
* 9.09 FIX EXOGENOUS TRANSFER PAYMENT LEVELS
*
  TP.FX(H,GW) = TP0(H,GW);
*
* 9.10 FIX TRANSFER PAYMENTS TO ZERO IF NOT IN ORIGINAL DATA
*
  TP.FX(H,G)$(NOT TP0(H,G)) = 0;
*



*option iterlim=0 ;

*option limrow = 1000;

*

*----------------------------------------------------------------
* 7. SOLVE AND OUTPUT PREPARATION
*----------------------------------------------------------------
* 7.1 MODEL FORMULATION
*----------------------------------------------------------------
*
  MODEL SCENARIO /ALL/;
*----------------------------------------------------------------
* 7.15  SAVE INITIAL VALUES
*----------------------------------------------------------------
*
$BATINCLUDE ScenOut0506.gms ORDSCEN('BASE')

*

*----------------------------------------------------------------
* 7.2 POLICY EXPERIMENT LOOP
*----------------------------------------------------------------

* SAVE SOLUTION VALUES FOR BASE SOLUTION (SHOULD MATCH INITIAL DATA)

*option nlp = minos;
SOLVE SCENARIO  MINIMIZING SPI USING NLP;



$BATINCLUDE ScenOut0506.gms ORDSCEN('B_A_U')

$batinclude diagnostics_agg.gms


*
*---------------------
* FIRST EXPERIMENT
*Scenario SCEN1


*option nlp = minos ;
*SCENARIO.optfile=1 ;

*    Reset all
$BATINCLUDE Reg06_agg.gms 0 0 0 0
*$BATINCLUDE REG.gms 16 ORDVAL('oilref') ORDVAL('cmfuel') -0.38 ;
$BATINCLUDE REG06_agg.GMS 1 ORDVAL('OILGAS') ORDVAL('oilref')  -10.0

*option iterlim=5 ;
*option sysout = on;
*if { ORDSCEN('SCEN1') > 3,
    SOLVE SCENARIO  MINIMIZING SPI USING NLP;
*};

*
$BATINCLUDE ScenOut0506.gms ORDSCEN('SCEN1')
* SOLVE SCENARIO MINIMIZING SPI USING NLP;


*----------------------
*SCENARIO 2

*
*Scenario SCEN2
*    Reset all
*$BATINCLUDE Reg.gms 0 0 0 0
*if { ORDSCEN('SCEN2') > 3,
*    SOLVE SCENARIO MINIMIZING SPI USING NLP;
*};



*
*

* SOLVE DRAM03 MaxIMIZING SPI USING NLP;
*$BATINCLUDE ScenOut.gms ORDSCEN('SCEN2')



*
*
*----------------------------------------------------------------
* 7.3 PUT RESULTS INTO OUTPUT FILE
*----------------------------------------------------------------
*
  PUT 'EDRAM0506 march 10                          ';
  LOOP(T, PUT T.TL);
  PUT /;
*
  PUT 'MODEL                                        ';
  LOOP(T, LOOP(MS$(R2('M-STAT',T) EQ ORD(MS) ), PUT MS.TE(MS) ) );
  PUT /;
*
  PUT 'SOLVER                                       ';
  LOOP(T, LOOP(SS$(R2('S-STAT',T) EQ ORD(SS) ), PUT SS.TE(SS) ) );
  PUT /;
*
  LOOP(R1H, PUT R1H.TE(R1H);
            LOOP(T, PUT R1(R1H,T) );
            PUT / );
*
  LOOP((R3H,Z)$SUM(T, R3(R3H,Z,T)), PUT R3H.TE(R3H), Z.TL;
                                    LOOP(T, PUT R3(R3H,Z,T) );
                                    PUT / );
*
  LOOP(I, PUT I.TL; PUT /;
          LOOP(R4LH, PUT R4H.TE(R4LH) I.TL;
*          LOOP(R4LH, PUT R4H.TE(R4LH)'    ';
                    LOOP(T, PUT R4(R4LH,I,T) );
                    PUT / ));
*
*
*
parameter R4new(AI,R4LH,T);
R4new(I,R4LH,T) = R4(R4LH,I,t);
*

*
*EOM 4/17/08 utilizing GDX facility for exporting results to excel
*These five lines dump the reporting parameters into 4 separate sheets
*within the workbook dram03.xls in the project directory.
$ontext
execute_unload "DRAM0506res.gdx" R4new R3 R2 R1
execute 'gdxxrw DRAM0506res.gdx output=dram0506res.xls par=R4new rng=R4!'
execute 'gdxxrw DRAM0506res.gdx output=dram0506res.xls par=R3 rng=R3!'
execute 'gdxxrw DRAM0506res.gdx output=dram0506res.xls par=R2 rng=R2!'
execute 'gdxxrw DRAM0506res.gdx output=dram0506res.xls par=R1 rng=R1!'

*execute_unload "DRAM0506ag.gdx" Sam
*execute 'gdxxrw DRAM0506ag.gdx output=dram0506ag.xls par=sam rng=R1!'

$offtext 